/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* Copy the first part of user declarations.  */
#line 1 "parse.y" /* yacc.c:339  */

// See the file "COPYING" in the main distribution directory for copyright.
#line 78 "parse.y" /* yacc.c:339  */

#include <stdlib.h>
#include <string.h>
#include <assert.h>

#include <set>
#include <string>

#include "zeek/input.h"
#include "zeek/ZeekList.h"
#include "zeek/Desc.h"
#include "zeek/Expr.h"
#include "zeek/Func.h"
#include "zeek/Stmt.h"
#include "zeek/Val.h"
#include "zeek/Var.h"
#include "zeek/RE.h"
#include "zeek/Scope.h"
#include "zeek/Reporter.h"
#include "zeek/ScriptCoverageManager.h"
#include "zeek/zeekygen/Manager.h"
#include "zeek/module_util.h"
#include "zeek/IntrusivePtr.h"
#include "zeek/script_opt/IDOptInfo.h"

extern const char* filename;  // Absolute path of file currently being parsed.
extern const char* last_filename; // Absolute path of last file parsed.
extern const char* last_tok_filename;
extern const char* last_last_tok_filename;

extern int conditional_epoch; // let's us track embedded conditionals

// Whether the file we're currently parsing includes @if conditionals.
extern bool current_file_has_conditionals;

YYLTYPE GetCurrentLocation();
extern int yyerror(const char[]);
extern int brolex();

#define YYLLOC_DEFAULT(Current, Rhs, N) \
	(Current) = (Rhs)[(N)];

using namespace zeek;
using namespace zeek::detail;

// Part of the module facility: while parsing, keep track of which
// module to put things in.
std::string zeek::detail::current_module = GLOBAL_MODULE_NAME;

bool is_export = false; // true if in an export {} block

// When parsing an expression for the debugger, where to put the result
// (obviously not reentrant).
extern Expr* g_curr_debug_expr;
extern bool in_debug;
extern const char* g_curr_debug_error;

static int in_when_cond = 0;
static int in_hook = 0;
int in_init = 0;
int in_record = 0;
static int in_record_redef = 0;
static int in_enum_redef = 0;
bool resolving_global_ID = false;
bool defining_global_ID = false;
std::vector<int> saved_in_init;

std::vector<std::set<const ID*>> locals_at_this_scope;
static std::unordered_set<const ID*> out_of_scope_locals;
static std::unordered_set<const ID*> warned_about_locals;

static Location func_hdr_location;
static int func_hdr_cond_epoch = 0;
EnumType* cur_enum_type = nullptr;
static ID* cur_decl_type_id = nullptr;

static void parse_new_enum(void)
	{
	// Starting a new enum definition.
	assert(cur_enum_type == nullptr);

	if ( cur_decl_type_id )
		{
		auto name = make_full_var_name(current_module.c_str(), cur_decl_type_id->Name());
		cur_enum_type = new EnumType(name);
		}
	else
		reporter->FatalError("incorrect syntax for enum type declaration");
	}

static void parse_redef_enum(ID* id)
	{
	// Redef an enum. id points to the enum to be redefined.
	// Let cur_enum_type point to it.
	assert(cur_enum_type == nullptr);

	// abort on errors; enums need to be accessible to continue parsing
	if ( ! id->GetType() )
		reporter->FatalError("unknown enum identifier \"%s\"", id->Name());
	else
		{
		if ( ! id->GetType() || id->GetType()->Tag() != TYPE_ENUM )
			reporter->FatalError("identifier \"%s\" is not an enum", id->Name());
		cur_enum_type = id->GetType()->AsEnumType();
		}
	}

static void extend_record(ID* id, std::unique_ptr<type_decl_list> fields,
                          std::unique_ptr<std::vector<AttrPtr>> attrs)
	{
	const auto& types = Type::Aliases(id->Name());

	if ( types.empty() )
		{
		id->Error("failed to redef record: no types found in alias map");
		return;
		}

	bool add_log_attr = false;

	if ( attrs )
		for ( const auto& at : *attrs )
			if ( at->Tag() == ATTR_LOG )
				{
				add_log_attr = true;
				break;
				}

	for ( const auto& t : types )
		{
		auto error = t->AsRecordType()->AddFields(*fields, add_log_attr);

		if ( error )
			{
			id->Error(error);
			break;
			}
		}
	}

static AttributesPtr
make_attributes(std::vector<AttrPtr>* attrs,
                TypePtr t, bool in_record, bool is_global)
	{
	if ( ! attrs )
		return nullptr;

	auto rval = make_intrusive<Attributes>(std::move(*attrs), std::move(t),
	                                       in_record, is_global);
	delete attrs;
	return rval;
	}

static bool expr_is_table_type_name(const Expr* expr)
	{
	if ( expr->Tag() != EXPR_NAME )
		return false;

	const auto& type = expr->GetType();

	if ( type->IsTable() )
		return true;

	if ( type->Tag() == TYPE_TYPE )
		return type->AsTypeType()->GetType()->IsTable();

	return false;
	}

static void build_global(ID* id, Type* t, InitClass ic, Expr* e,
                         std::vector<AttrPtr>* attrs, DeclType dt)
	{
	IDPtr id_ptr{AdoptRef{}, id};
	TypePtr t_ptr{AdoptRef{}, t};
	ExprPtr e_ptr{AdoptRef{}, e};

	auto attrs_ptr = attrs ? std::make_unique<std::vector<AttrPtr>>(*attrs) : nullptr;

	add_global(id_ptr, std::move(t_ptr), ic, e_ptr, std::move(attrs_ptr), dt);

	id->GetOptInfo()->AddInitExpr(e_ptr);

	if ( dt == VAR_REDEF )
		zeekygen_mgr->Redef(id, ::filename, ic, std::move(e_ptr));
	else
		zeekygen_mgr->Identifier(std::move(id_ptr));
	}

static StmtPtr build_local(ID* id, Type* t, InitClass ic, Expr* e,
                           std::vector<AttrPtr>* attrs, DeclType dt,
                           bool do_coverage)
	{
	IDPtr id_ptr{AdoptRef{}, id};
	TypePtr t_ptr{AdoptRef{}, t};
	ExprPtr e_ptr{AdoptRef{}, e};

	auto attrs_ptr = attrs ? std::make_unique<std::vector<AttrPtr>>(*attrs) : nullptr;

	auto init = add_local(std::move(id_ptr), std::move(t_ptr), ic,
	                      e_ptr, std::move(attrs_ptr), dt);

	id->GetOptInfo()->AddInitExpr(std::move(e_ptr));

	if ( do_coverage )
		script_coverage_mgr.AddStmt(init.get());

	return init;
	}

#line 279 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "broparse.h".  */
#ifndef YY_YY_BUILDDIR_BUILD_BUILD_ZEEK_4_2_0_AARCH64_REDHAT_LINUX_GNU_SRC_BROPARSE_H_INCLUDED
# define YY_YY_BUILDDIR_BUILD_BUILD_ZEEK_4_2_0_AARCH64_REDHAT_LINUX_GNU_SRC_BROPARSE_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 1
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    TOK_ADD = 258,
    TOK_ADD_TO = 259,
    TOK_ADDR = 260,
    TOK_ANY = 261,
    TOK_ATENDIF = 262,
    TOK_ATELSE = 263,
    TOK_ATIF = 264,
    TOK_ATIFDEF = 265,
    TOK_ATIFNDEF = 266,
    TOK_BOOL = 267,
    TOK_BREAK = 268,
    TOK_CASE = 269,
    TOK_OPTION = 270,
    TOK_CONST = 271,
    TOK_CONSTANT = 272,
    TOK_COPY = 273,
    TOK_COUNT = 274,
    TOK_DEFAULT = 275,
    TOK_DELETE = 276,
    TOK_DOUBLE = 277,
    TOK_ELSE = 278,
    TOK_ENUM = 279,
    TOK_EVENT = 280,
    TOK_EXPORT = 281,
    TOK_FALLTHROUGH = 282,
    TOK_FILE = 283,
    TOK_FOR = 284,
    TOK_FUNCTION = 285,
    TOK_GLOBAL = 286,
    TOK_HOOK = 287,
    TOK_ID = 288,
    TOK_IF = 289,
    TOK_INT = 290,
    TOK_INTERVAL = 291,
    TOK_LIST = 292,
    TOK_LOCAL = 293,
    TOK_MODULE = 294,
    TOK_NEXT = 295,
    TOK_OF = 296,
    TOK_OPAQUE = 297,
    TOK_PATTERN = 298,
    TOK_PATTERN_END = 299,
    TOK_PATTERN_TEXT = 300,
    TOK_PORT = 301,
    TOK_PRINT = 302,
    TOK_RECORD = 303,
    TOK_REDEF = 304,
    TOK_REMOVE_FROM = 305,
    TOK_RETURN = 306,
    TOK_SCHEDULE = 307,
    TOK_SET = 308,
    TOK_STRING = 309,
    TOK_SUBNET = 310,
    TOK_SWITCH = 311,
    TOK_TABLE = 312,
    TOK_TIME = 313,
    TOK_TIMEOUT = 314,
    TOK_TIMER = 315,
    TOK_TYPE = 316,
    TOK_UNION = 317,
    TOK_VECTOR = 318,
    TOK_WHEN = 319,
    TOK_WHILE = 320,
    TOK_AS = 321,
    TOK_IS = 322,
    TOK_ATTR_ADD_FUNC = 323,
    TOK_ATTR_DEFAULT = 324,
    TOK_ATTR_OPTIONAL = 325,
    TOK_ATTR_REDEF = 326,
    TOK_ATTR_DEL_FUNC = 327,
    TOK_ATTR_EXPIRE_FUNC = 328,
    TOK_ATTR_EXPIRE_CREATE = 329,
    TOK_ATTR_EXPIRE_READ = 330,
    TOK_ATTR_EXPIRE_WRITE = 331,
    TOK_ATTR_RAW_OUTPUT = 332,
    TOK_ATTR_ON_CHANGE = 333,
    TOK_ATTR_BROKER_STORE = 334,
    TOK_ATTR_BROKER_STORE_ALLOW_COMPLEX = 335,
    TOK_ATTR_BACKEND = 336,
    TOK_ATTR_PRIORITY = 337,
    TOK_ATTR_LOG = 338,
    TOK_ATTR_ERROR_HANDLER = 339,
    TOK_ATTR_TYPE_COLUMN = 340,
    TOK_ATTR_DEPRECATED = 341,
    TOK_ATTR_IS_ASSIGNED = 342,
    TOK_ATTR_IS_USED = 343,
    TOK_DEBUG = 344,
    TOK_NO_TEST = 345,
    TOK_OR_OR = 346,
    TOK_AND_AND = 347,
    TOK_LE = 348,
    TOK_GE = 349,
    TOK_EQ = 350,
    TOK_NE = 351,
    TOK_IN = 352,
    TOK_NOT_IN = 353,
    TOK_INCR = 354,
    TOK_DECR = 355,
    TOK_HAS_FIELD = 356,
    TOK_HAS_ATTR = 357
  };
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 288 "parse.y" /* yacc.c:355  */

	bool b;
	char* str;
	zeek::detail::ID* id;
	zeek::IDPList* id_l;
	zeek::detail::InitClass ic;
	zeek::Val* val;
	zeek::RE_Matcher* re;
	zeek::detail::Expr* expr;
	zeek::detail::EventExpr* event_expr;
	zeek::detail::Stmt* stmt;
	zeek::detail::ListExpr* list;
	zeek::Type* type;
	zeek::RecordType* record;
	zeek::FuncType* func_type;
	zeek::TypeList* type_l;
	zeek::TypeDecl* type_decl;
	zeek::type_decl_list* type_decl_l;
	zeek::detail::Case* c_case;
	zeek::detail::case_list* case_l;
	zeek::detail::Attr* attr;
	std::vector<zeek::detail::AttrPtr>* attr_l;
	zeek::detail::AttrTag attrtag;
	zeek::FuncType::Capture* capture;
	std::vector<zeek::FuncType::Capture*>* captures;

#line 449 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:355  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif

/* Location type.  */
#if ! defined YYLTYPE && ! defined YYLTYPE_IS_DECLARED
typedef struct YYLTYPE YYLTYPE;
struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
};
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif


extern YYSTYPE yylval;
extern YYLTYPE yylloc;
int yyparse (void);

#endif /* !YY_YY_BUILDDIR_BUILD_BUILD_ZEEK_4_2_0_AARCH64_REDHAT_LINUX_GNU_SRC_BROPARSE_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 480 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
             && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE) + sizeof (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  5
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   3138

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  127
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  88
/* YYNRULES -- Number of rules.  */
#define YYNRULES  272
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  743

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   357

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   115,     2,     2,   117,   112,   107,     2,
     120,   121,   110,   108,    91,   109,     2,   111,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    94,   126,
      97,    92,    98,    93,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   118,     2,   119,   106,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   124,   105,   125,   116,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    95,    96,    99,   100,
     101,   102,   103,   104,   113,   114,   122,   123
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   318,   318,   333,   333,   340,   341,   345,   348,   352,
     352,   352,   357,   363,   369,   375,   381,   387,   393,   429,
     435,   441,   447,   453,   459,   465,   471,   477,   483,   489,
     495,   501,   507,   513,   519,   525,   531,   537,   543,   549,
     561,   570,   579,   581,   587,   594,   593,   603,   609,   617,
     642,   649,   655,   655,   655,   663,   670,   677,   683,   676,
     726,   726,   739,   745,   748,   754,   819,   825,   825,   839,
     846,   852,   860,   866,   874,   876,   880,   886,   894,   896,
     905,   918,   926,   936,   941,   946,   951,   956,   961,   966,
     971,   976,   981,   986,   991,   996,  1001,  1007,  1014,  1016,
    1013,  1023,  1030,  1030,  1037,  1045,  1053,  1059,  1065,  1071,
    1077,  1083,  1089,  1095,  1115,  1117,  1125,  1130,  1136,  1149,
    1151,  1154,  1158,  1160,  1162,  1167,  1176,  1182,  1182,  1185,
    1190,  1195,  1200,  1206,  1205,  1214,  1216,  1218,  1213,  1231,
    1230,  1242,  1241,  1248,  1251,  1252,  1256,  1258,  1260,  1262,
    1264,  1269,  1278,  1292,  1301,  1312,  1322,  1311,  1342,  1348,
    1341,  1374,  1379,  1406,  1409,  1413,  1415,  1423,  1450,  1453,
    1457,  1459,  1464,  1467,  1471,  1472,  1473,  1474,  1478,  1478,
    1478,  1481,  1485,  1487,  1489,  1493,  1517,  1519,  1523,  1525,
    1533,  1535,  1537,  1539,  1541,  1543,  1545,  1547,  1549,  1551,
    1553,  1555,  1557,  1559,  1561,  1563,  1565,  1567,  1569,  1571,
    1573,  1575,  1595,  1594,  1611,  1619,  1627,  1633,  1639,  1645,
    1650,  1655,  1663,  1671,  1679,  1687,  1695,  1703,  1711,  1719,
    1725,  1732,  1742,  1749,  1758,  1768,  1776,  1782,  1787,  1794,
    1798,  1820,  1823,  1827,  1830,  1833,  1838,  1841,  1849,  1855,
    1872,  1900,  1905,  1938,  1959,  1961,  1969,  1991,  1991,  1996,
    1996,  1996,  2001,  2001,  2006,  2044,  2058,  2061,  2064,  2067,
    2070,  2073,  2087
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "TOK_ADD", "TOK_ADD_TO", "TOK_ADDR",
  "TOK_ANY", "TOK_ATENDIF", "TOK_ATELSE", "TOK_ATIF", "TOK_ATIFDEF",
  "TOK_ATIFNDEF", "TOK_BOOL", "TOK_BREAK", "TOK_CASE", "TOK_OPTION",
  "TOK_CONST", "TOK_CONSTANT", "TOK_COPY", "TOK_COUNT", "TOK_DEFAULT",
  "TOK_DELETE", "TOK_DOUBLE", "TOK_ELSE", "TOK_ENUM", "TOK_EVENT",
  "TOK_EXPORT", "TOK_FALLTHROUGH", "TOK_FILE", "TOK_FOR", "TOK_FUNCTION",
  "TOK_GLOBAL", "TOK_HOOK", "TOK_ID", "TOK_IF", "TOK_INT", "TOK_INTERVAL",
  "TOK_LIST", "TOK_LOCAL", "TOK_MODULE", "TOK_NEXT", "TOK_OF",
  "TOK_OPAQUE", "TOK_PATTERN", "TOK_PATTERN_END", "TOK_PATTERN_TEXT",
  "TOK_PORT", "TOK_PRINT", "TOK_RECORD", "TOK_REDEF", "TOK_REMOVE_FROM",
  "TOK_RETURN", "TOK_SCHEDULE", "TOK_SET", "TOK_STRING", "TOK_SUBNET",
  "TOK_SWITCH", "TOK_TABLE", "TOK_TIME", "TOK_TIMEOUT", "TOK_TIMER",
  "TOK_TYPE", "TOK_UNION", "TOK_VECTOR", "TOK_WHEN", "TOK_WHILE", "TOK_AS",
  "TOK_IS", "TOK_ATTR_ADD_FUNC", "TOK_ATTR_DEFAULT", "TOK_ATTR_OPTIONAL",
  "TOK_ATTR_REDEF", "TOK_ATTR_DEL_FUNC", "TOK_ATTR_EXPIRE_FUNC",
  "TOK_ATTR_EXPIRE_CREATE", "TOK_ATTR_EXPIRE_READ",
  "TOK_ATTR_EXPIRE_WRITE", "TOK_ATTR_RAW_OUTPUT", "TOK_ATTR_ON_CHANGE",
  "TOK_ATTR_BROKER_STORE", "TOK_ATTR_BROKER_STORE_ALLOW_COMPLEX",
  "TOK_ATTR_BACKEND", "TOK_ATTR_PRIORITY", "TOK_ATTR_LOG",
  "TOK_ATTR_ERROR_HANDLER", "TOK_ATTR_TYPE_COLUMN", "TOK_ATTR_DEPRECATED",
  "TOK_ATTR_IS_ASSIGNED", "TOK_ATTR_IS_USED", "TOK_DEBUG", "TOK_NO_TEST",
  "','", "'='", "'?'", "':'", "TOK_OR_OR", "TOK_AND_AND", "'<'", "'>'",
  "TOK_LE", "TOK_GE", "TOK_EQ", "TOK_NE", "TOK_IN", "TOK_NOT_IN", "'|'",
  "'^'", "'&'", "'+'", "'-'", "'*'", "'/'", "'%'", "TOK_INCR", "TOK_DECR",
  "'!'", "'~'", "'$'", "'['", "']'", "'('", "')'", "TOK_HAS_FIELD",
  "TOK_HAS_ATTR", "'{'", "'}'", "';'", "$accept", "zeek", "$@1",
  "decl_list", "opt_expr", "when_condition", "$@2", "$@3", "expr", "$@4",
  "$@5", "$@6", "$@7", "$@8", "$@9", "$@10", "expr_list", "opt_expr_list",
  "enum_body", "enum_body_list", "enum_body_elem", "type", "$@11", "$@12",
  "$@13", "type_list", "type_decl_list", "type_decl", "formal_args",
  "formal_args_decl_list", "formal_args_decl", "decl", "$@14", "$@15",
  "$@16", "$@17", "$@18", "$@19", "$@20", "conditional_list",
  "conditional", "func_hdr", "func_body", "$@21", "$@22", "lambda_body",
  "$@23", "$@24", "anonymous_function", "begin_lambda", "opt_captures",
  "capture_list", "capture", "opt_deep", "func_params", "opt_type",
  "init_class", "opt_init", "$@25", "$@26", "init", "index_slice",
  "opt_attr", "attr_list", "attr", "stmt", "$@27", "stmt_list", "event",
  "case_list", "case", "case_type_list", "case_type", "for_head",
  "local_id_list", "local_id", "global_id", "$@28", "def_global_id",
  "$@29", "$@30", "event_id", "$@31", "global_or_event_id", "resolve_id",
  "opt_no_test", "opt_no_test_block", "opt_deprecated", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,    44,    61,    63,    58,   346,   347,    60,    62,   348,
     349,   350,   351,   352,   353,   124,    94,    38,    43,    45,
      42,    47,    37,   354,   355,    33,   126,    36,    91,    93,
      40,    41,   356,   357,   123,   125,    59
};
# endif

#define YYPACT_NINF -663

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-663)))

#define YYTABLE_NINF -182

#define yytable_value_is_error(Yytable_value) \
  (!!((Yytable_value) == (-182)))

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
     -63,  -663,    94,  2484,  2570,  -663,  -663,  -663,   -89,   -22,
      17,  -663,  -663,  -663,    21,  -663,  -663,  -663,   108,   242,
    -663,  -663,  -663,  -663,  1003,  -663,    50,    57,  -663,  -663,
     147,    74,  2570,    87,    88,    91,  2570,  2570,  2570,  -663,
    2570,  2570,  2570,  2570,   164,  2449,  2570,  2197,  -663,  -663,
    2570,   172,   185,   127,  -663,   127,   104,   195,  -663,   104,
     127,   104,   110,  -663,  -663,  -663,   127,   195,   149,  -663,
    2570,   115,   147,  2570,   213,   122,   133,   137,   147,   132,
    2570,  2421,  2570,   148,   150,  -663,  -663,   739,  -663,   177,
    -663,  1003,  2570,   254,   151,   104,  2570,  -663,   182,  2570,
    1173,  2570,  -663,  2570,  2261,    92,    92,   232,    92,    92,
      92,    92,    -7,  -663,  2197,   -76,  1429,  2570,  2570,  2718,
    2718,  2570,  2602,  2570,  2570,  2570,  2570,  2570,  2570,  2570,
    2570,  2570,  2570,  2570,  2570,  2570,  2570,  2570,  2570,  2570,
    2570,   245,  2602,  -663,   251,  1493,   165,   166,  2718,     8,
    -663,     8,   261,  1622,  -663,  -663,  -663,  1622,     8,  1622,
    -663,   294,   104,  -663,     8,  -663,  -663,    96,   859,   209,
     127,   979,   180,   176,   209,   -10,  2570,    85,   209,   -70,
     186,   209,  1043,  1237,  -663,  2570,   217,   209,  2570,  -663,
    1557,  -663,   -36,  -663,   275,  -663,  -663,  -663,  2917,  2570,
     -39,   213,   218,   191,  2570,   197,   437,   272,  2570,   227,
    2570,  -663,  -663,  2197,  2197,  -663,  -663,  -663,  -663,  -663,
     196,   202,   282,   104,   205,  -663,  -663,  -663,   288,   289,
    -663,  -663,   214,   219,  -663,  -663,   222,  -663,  -663,   226,
     307,  -663,  -663,  -663,  2197,  1621,  2843,  2917,  2943,  2943,
    2943,  2943,  2943,  2943,    81,    81,  1446,    43,   416,   171,
     171,    92,    92,    92,  -663,   257,  1685,   -29,  2570,  -663,
    -663,  -663,  -663,  -663,  -663,  -663,  -663,  1238,  -663,  1238,
     258,   233,   -66,  -663,   263,   264,  -663,  -663,   266,   267,
     268,   271,   273,  -663,   279,   283,  -663,   284,   285,  -663,
    -663,   286,   299,  -663,  -663,  -663,  1622,  -663,   224,  -663,
    1238,  -663,   240,  1622,   363,  1238,  2718,  -663,  -663,  -663,
     209,  -663,  -663,     8,   209,  2570,   209,  -663,   -12,   147,
    1749,     8,  -663,   209,  -663,  -663,   209,  -663,   249,  2570,
    1813,  -663,  -663,  -663,  1109,  -663,   254,  -663,  -663,  -663,
    2197,  -663,   269,  1622,   253,  -663,  -663,  2197,  -663,  2197,
    -663,   261,  2718,  -663,   261,  2718,   359,  -663,  2718,  2718,
    2718,  2718,  2570,  2570,  -663,  -663,  1622,  1140,  1622,  2718,
     310,   261,   261,  2570,  2570,  2570,  2570,  2570,  2570,  2570,
    2570,  2570,  2570,  2570,  2570,   389,  -663,  -663,  1622,  -663,
    -663,   291,  1622,  1622,  -663,  -663,  1238,  -663,   287,  -663,
     376,  2570,    52,  -663,  1003,  1238,  -663,   292,  -663,    31,
    1003,  2197,  1003,   643,   209,  -663,  1003,  -663,  -663,  -663,
     151,   377,   298,  -663,   311,  -663,  -663,  -663,  -663,    55,
      66,   -64,  -663,  2749,   293,  2197,   312,   302,  2570,  2197,
    -663,   304,  1622,  2718,  -663,  -663,  2197,  2197,  2197,  2197,
    2197,  2197,  2197,  2197,  2197,  2197,  2197,  2197,  -663,   313,
     377,  -663,   317,   319,  1003,  1622,  -663,   332,  1877,   147,
      -2,   413,  1622,  1003,  2553,   343,  -663,  -663,   379,  -663,
    -663,  -663,  -663,   321,  1622,  -663,    -5,   324,   360,  -663,
    -663,  -663,   417,  2718,  -663,   415,  -663,  -663,  -663,  -663,
     367,   334,  -663,  -663,  -663,  -663,  -663,   338,  -663,  -663,
    -663,   339,   340,  2570,  -663,  -663,   432,  2570,  1003,   342,
     414,  2777,     2,    73,  -663,  -663,  2570,  -663,  -663,   380,
       7,  -663,  -663,   377,   382,   349,  -663,  -663,  2718,   309,
    -663,   351,   417,  -663,   209,  1941,   375,  2005,  -663,   209,
    2570,   418,  -663,   420,  -663,  1003,  1301,   462,   400,   470,
    -663,  2718,  -663,  -663,  -663,  -663,   366,  -663,  -663,  2570,
    -663,  -663,  1365,   455,  1003,  -663,  1003,   217,  -663,  -663,
    -663,  1622,  1622,  2069,   217,  -663,  -663,   369,   370,  -663,
    -663,   763,  -663,  -663,   883,  -663,  -663,  -663,   147,   372,
     373,  2602,  2602,  2602,  2602,  2602,  2602,   464,  2602,  2602,
    2777,  2777,  2602,  2602,  2602,  2602,  2602,  2602,  2602,  2602,
    2602,  2602,  2602,  2602,  2602,  2602,  2602,  2602,  2602,  2602,
    2602,  2602,  2325,   457,   388,   458,   391,   469,  2602,  2602,
     421,  2570,  -663,   278,   278,   278,   278,   278,   278,    -6,
    2325,  2325,  2325,  2133,  2870,  2990,  3016,  3016,  3016,  3016,
    3016,  3016,  2586,  2586,  1510,   394,  1318,   193,   193,   278,
     278,   278,  2777,   261,  2777,  2718,  2777,  2325,  2990,  2602,
     396,  2570,  2602,  2602,   397,    77,  2325,  1686,   401,  2325,
    2796,  -663,   474,   438,   439,   443,   445,   447,   449,   450,
     451,   454,   456,   463,   465,  1686,  -663,  2777,  2602,  2602,
    2602,  2602,  2602,  2602,  2602,  2602,  2602,  2602,  2602,  2602,
    1686,  2325,  2325,  2325,  2325,  2325,  2325,  2325,  2325,  2325,
    2325,  2325,  2325
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       6,     3,     0,   239,     0,     1,   149,   150,     0,     0,
       0,   259,   259,   262,     0,   259,   259,   259,     0,   257,
     257,     5,   143,   141,     2,    66,     0,   164,    60,    65,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    67,
       0,     0,     0,     0,     0,     0,     0,     4,    63,    42,
       0,     0,     0,   173,   257,   173,     0,     0,   127,     0,
     173,     0,     0,   257,   262,   257,   173,     0,     0,   144,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   212,   236,     0,   237,    42,
     238,     0,     0,   169,     0,     0,     0,   256,     0,     0,
       0,    75,    52,    75,     0,    19,    18,     0,    14,    15,
      16,    17,   164,    50,    73,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     8,    57,     0,     0,     0,     0,     0,   174,
     260,   174,   121,   187,   264,   263,     6,   187,   174,   187,
     126,     0,     0,   135,   174,   258,   139,     0,     0,   267,
     173,     0,     0,     0,   267,     0,     0,   173,   267,     0,
       0,   267,     0,     0,     9,     0,   269,   267,     0,   219,
       0,   168,     0,   166,     0,   158,   161,   162,    61,     0,
       0,     0,    74,     0,    75,     0,    69,     0,     0,     0,
       0,    49,    12,    21,    23,    93,    95,    83,    85,    86,
       0,     0,   111,     0,     0,   265,    84,    88,   104,     0,
      90,    92,     0,     0,    89,    94,     0,    87,    91,     0,
       0,    70,   113,    71,    39,     0,    31,    30,    34,    36,
      35,    37,    32,    33,    47,    48,    28,    29,    27,    20,
      22,    24,    25,    26,    43,     0,    73,     0,    75,    62,
     146,   147,   148,   172,   176,   177,   175,   178,   261,   178,
       0,     0,   119,   124,     0,     0,   191,   192,     0,     0,
       0,     0,     0,   205,     0,     0,   199,     0,     0,   208,
     209,     0,   210,   193,   194,   152,   186,   189,     0,   151,
     178,   153,     0,   187,     0,   178,     0,   155,   145,   142,
     267,   266,   222,   174,   267,    75,   267,   223,     0,     0,
       0,   174,   221,   267,     9,   224,   267,   242,     0,     0,
       0,   268,   239,   235,     0,    13,   169,   163,   167,   239,
      40,    51,     0,   187,     0,    56,    68,    44,    45,    72,
     102,   121,     0,   107,   121,     0,     0,    98,     0,     0,
       0,     0,     0,     8,    41,    58,   187,     0,   187,     0,
     171,     0,   120,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   188,   128,   187,   133,
     154,     0,   187,   187,   239,   226,   178,   227,     0,   215,
       0,     0,     0,   255,     0,   178,   214,     0,   225,     0,
       0,    10,     0,     0,   267,   165,   159,    64,    55,    53,
       0,     0,     0,   110,     0,   105,   112,   117,   115,     0,
       0,     0,   106,    38,     0,     7,     0,     0,    75,   184,
     179,     0,   187,     0,   123,   122,   195,   190,   196,   201,
     202,   203,   204,   197,   198,   200,   206,   207,   211,     0,
       0,   136,     0,     0,   156,   187,   240,     0,     0,     0,
       0,   216,   187,     0,     0,     0,   218,   241,   230,    11,
     220,   213,   234,     0,   187,    46,   272,     0,    76,    78,
     108,   109,    99,     0,    97,     0,   101,   185,    59,   130,
      74,     0,   180,   131,   125,   170,   129,     0,   117,   132,
     140,     0,     0,     0,   250,   254,     0,     0,     0,     0,
     232,     0,     0,     0,   247,   239,     0,   160,    54,   270,
       0,    82,   103,    77,     0,     0,   116,   114,     0,     0,
     182,     0,   137,   157,   267,     0,     0,     0,   217,   267,
       0,   248,   239,     0,   239,   245,     0,     0,   272,     0,
      79,     0,   100,    96,   183,   134,     0,   229,   252,     0,
     251,   228,     0,     0,   243,   246,   244,   269,   271,    80,
      81,   187,   187,     0,   269,   249,   239,     0,     0,   253,
     239,     0,   118,   138,     0,   231,   233,    60,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    73,   111,     0,   104,     0,     0,     0,     0,
       0,    75,    52,    19,    18,    14,    15,    16,    17,   164,
      21,    23,    39,     0,    31,    30,    34,    36,    35,    37,
      32,    33,    47,    48,    28,    29,    27,    20,    22,    24,
      25,    26,     0,   121,     0,     0,     0,    72,    61,     0,
       0,    75,     0,     0,     0,     0,    40,   187,     0,    44,
      38,   171,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   186,    53,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     187,   195,   190,   196,   201,   202,   203,   204,   197,   198,
     200,   206,   207
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -663,  -663,  -663,   398,   156,   225,  -663,  -663,    -4,  -663,
    -105,  -158,  -663,  -663,   -47,  -663,   -27,  -102,    97,  -663,
      18,  -100,  -663,  -663,  -663,  -353,    44,  -663,  -350,  -663,
    -199,  -663,  -663,  -663,  -663,  -663,  -663,  -663,  -663,  -663,
       6,  -663,  -663,  -663,  -663,   134,  -663,  -663,  -663,   539,
    -663,  -663,   223,  -663,    83,    -1,  -101,  -266,  -663,  -663,
    -663,   -21,  -151,  -662,  -299,   -86,  -663,  -320,   371,  -663,
    -663,  -663,     5,  -663,  -663,   -68,    10,  -663,   280,  -663,
    -663,   506,  -663,   504,  -663,  -107,  -547,     9
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     2,     4,     3,   265,   338,   339,   489,    87,   430,
     204,   494,   268,   446,    96,   107,   202,   203,   497,   498,
     499,   438,   437,   545,   431,   439,   502,   546,   281,   282,
     283,    21,   156,   470,   314,   518,   576,   316,    69,   167,
      88,    23,   319,   404,   521,   196,   349,   493,    48,   209,
      95,   192,   193,   194,   363,   149,   277,   376,   377,   512,
     450,    49,   428,   306,   307,    90,   186,    24,   173,   419,
     487,   533,   534,    91,   412,    98,    66,    67,    53,    54,
     278,    56,    57,   155,   242,   322,   342,   541
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      47,   205,   305,    89,   170,   189,   309,   396,   311,    22,
     177,   432,   274,   378,   434,   210,   440,   441,   115,   241,
     243,   210,   423,   328,   568,   381,     1,   503,   100,   426,
      68,    50,   104,   105,   106,   715,   108,   109,   110,   111,
     596,   114,   116,   211,   398,   484,   145,   600,   273,   402,
     279,   485,   210,   179,   151,   346,   333,   310,   275,   158,
     382,   506,   210,   315,   150,   164,   168,   327,   715,   171,
      89,   332,   200,   161,   335,   163,   114,   182,   183,   410,
     343,   539,   351,   347,   474,   208,   692,   540,   190,   526,
     374,   411,   198,   648,     5,   114,   562,   114,    51,   114,
     276,   527,   354,     6,     7,     8,     9,    10,   329,   119,
     120,    93,    93,   213,   214,   267,   569,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,    52,   266,   153,
     475,    62,   157,   479,   159,    58,   503,   119,   120,   482,
     135,   136,   137,   138,   139,   140,   486,   503,   119,   120,
     141,   142,   400,   143,   563,   144,   375,   564,   503,   323,
      92,   480,   330,   318,   504,    93,   331,   199,   197,   148,
      97,   340,   454,   455,   344,   505,   133,   134,   135,   136,
     137,   138,   139,   140,    99,   350,   702,   112,   141,   142,
     114,   143,   256,   144,   357,   146,   359,   101,   102,   141,
     142,   103,   143,   405,   144,   565,   403,   407,   147,   409,
     317,   148,   406,   408,   152,   447,   416,   451,   154,   418,
     415,     6,     7,     8,     9,    10,   160,   119,   120,    11,
      12,   169,   584,   166,   586,   313,   172,   469,   174,    13,
      14,   472,   473,   175,    15,    16,    17,   176,   178,   620,
     621,   413,   433,    18,   114,   435,    63,    64,   184,   188,
     185,   442,   191,    19,   199,   195,   601,   207,   264,   452,
     604,   138,   139,   140,   269,    20,   271,   272,   141,   142,
      65,   143,    55,   144,   280,    59,    60,    61,   312,   321,
     325,   514,   326,   639,   640,   641,   334,   341,   348,   210,
     141,   142,   353,   143,    22,   144,   356,   492,   355,   358,
     360,   114,   361,   362,   522,   364,    25,    26,   481,   365,
     366,   529,   695,   694,   488,   421,   490,   368,   367,    27,
     369,    28,    29,   538,   620,   621,   511,    30,   371,   397,
     370,   373,   379,   515,   380,   383,   384,    31,   385,   386,
     387,    32,    33,   388,   399,   389,    34,   401,   443,   445,
     420,   390,    35,   449,   429,   391,   392,   393,   394,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   395,   436,    89,   427,   141,   142,   530,   143,    89,
     144,    89,    89,   547,   453,    89,   468,   478,   476,   477,
     496,   525,   507,   483,    36,   471,   396,    37,    38,   500,
      39,   510,    40,    41,    42,    43,    44,    45,   509,    46,
     513,   561,   501,   508,   574,   523,   528,   535,   536,   516,
     597,   598,   558,   519,   114,   520,   537,   577,   573,   542,
     544,   543,   581,    89,    25,    26,   548,   532,   549,   550,
     620,   621,    89,   551,   553,   556,   554,    27,   559,    28,
      29,   591,   567,   560,   572,    30,   571,   575,   579,   588,
     642,   531,   119,   120,   583,    31,   539,   590,   595,    32,
      33,   592,   651,   652,    34,   602,   603,   659,   682,   684,
      35,   636,   637,   638,   639,   640,   641,    89,   683,   685,
     686,   141,   142,   689,   143,   717,   144,   697,   701,   555,
     241,   243,   716,   557,   136,   137,   138,   139,   140,   444,
     718,   719,   566,   141,   142,   720,   143,   721,   144,   722,
     650,   723,   724,   725,    89,   359,   726,   691,   727,   690,
      40,    41,    42,    43,   308,   728,   582,   729,   730,   417,
     649,   570,   552,    89,   495,    89,    94,   517,   585,   425,
     162,   165,   352,     0,     0,   593,     0,   589,     0,   538,
      89,     0,   433,    89,   435,     0,   442,     0,     0,   698,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   653,   654,   655,
     656,   657,   658,     0,   660,   661,     0,   573,   662,   663,
     664,   665,   666,   667,   668,   669,   670,   671,   672,   673,
     674,   675,   676,   677,   678,   679,   680,   681,     0,     0,
       0,     0,     0,     0,   687,   688,    70,   114,     0,     0,
       6,     7,     8,     9,    10,     0,    71,     0,     0,    72,
      25,    26,     0,     0,    73,     0,     0,     0,    74,     0,
      75,     0,    76,    27,     0,    28,    29,    77,     0,     0,
       0,    78,     0,    79,     0,   696,     0,   114,   699,   700,
      80,    31,     0,     0,    81,    32,    33,     0,     0,    82,
      34,     0,     0,     0,     0,     0,    35,    83,    84,     0,
       0,     0,     0,     0,   731,   732,   733,   734,   735,   736,
     737,   738,   739,   740,   741,   742,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   117,     0,     0,     0,     0,    36,     0,
       0,    37,    38,     0,    39,     0,    40,    41,    42,    43,
      44,    45,     0,    46,     0,     0,    70,    85,   491,    86,
       6,     7,     8,     9,    10,     0,    71,     0,     0,    72,
      25,    26,     0,     0,    73,     0,     0,     0,    74,   118,
      75,     0,    76,    27,     0,    28,    29,    77,     0,     0,
       0,    78,     0,    79,     0,   119,   120,     0,     0,     0,
      80,    31,     0,     0,    81,    32,    33,     0,     0,    82,
      34,     0,     0,     0,     0,     0,    35,    83,    84,     0,
       0,   121,   122,     0,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,     0,     0,     0,     0,   141,   142,     0,   143,
       0,   144,     0,   117,     0,   187,     0,     0,    36,     0,
       0,    37,    38,     0,    39,     0,    40,    41,    42,    43,
      44,    45,     0,    46,     0,     0,    70,    85,   605,    86,
       6,     7,     8,     9,    10,     0,    71,     0,     0,    72,
      25,    26,     0,     0,    73,     0,     0,     0,    74,   118,
      75,     0,    76,    27,     0,    28,    29,    77,     0,     0,
       0,    78,     0,    79,     0,   119,   120,     0,     0,     0,
      80,    31,     0,     0,    81,    32,    33,     0,     0,    82,
      34,     0,     0,     0,     0,     0,    35,    83,    84,     0,
       0,   121,   122,     0,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,     0,     0,     0,     0,   141,   142,     0,   143,
       0,   144,     0,   117,     0,   320,     0,     0,    36,     0,
       0,    37,    38,     0,    39,     0,    40,    41,    42,    43,
      44,    45,     0,    46,     0,     0,    70,    85,   606,    86,
       6,     7,     8,     9,    10,     0,    71,     0,     0,    72,
      25,    26,     0,     0,    73,     0,     0,     0,    74,   118,
      75,     0,    76,    27,     0,    28,    29,    77,     0,     0,
       0,    78,     0,    79,     0,   119,   120,   117,     0,     0,
      80,    31,     0,     0,    81,    32,    33,     0,     0,    82,
      34,     0,     0,     0,     0,     0,    35,    83,    84,     0,
       0,   121,   122,     0,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,     0,   118,     0,     0,   141,   142,     0,   143,
       0,   144,     0,     0,     0,   324,     0,     0,    36,   119,
     120,    37,    38,   117,    39,     0,    40,    41,    42,    43,
      44,    45,     0,    46,     0,     0,     0,    85,     0,    86,
       0,     0,     0,     0,     0,   121,   122,     0,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,     0,    25,    26,   118,
     141,   142,     0,   143,     0,   144,     0,     0,     0,   336,
      27,     0,    28,    29,     0,   119,   120,   117,    30,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    31,     0,
       0,     0,    32,    33,     0,     0,     0,    34,     0,     0,
       0,   121,   122,    35,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,     0,   118,     0,     0,   141,   142,     0,   143,
       0,   144,     0,     0,     0,   424,     0,     0,     0,   119,
     120,   117,     0,     0,     0,    36,     0,     0,    37,    38,
       0,    39,     0,    40,    41,    42,    43,    44,    45,     0,
      46,     0,     0,     0,   448,   121,   122,     0,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,     0,   118,     0,     0,
     141,   142,     0,   143,     0,   144,     0,   201,     0,     0,
       0,     0,     0,   119,   120,   117,  -181,  -181,  -181,  -181,
    -181,  -181,  -181,  -181,  -181,  -181,  -181,  -181,  -181,  -181,
    -181,  -181,  -181,  -181,  -181,  -181,  -181,     0,     0,   121,
     122,     0,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
       0,   118,     0,     0,   141,   142,     0,   143,     0,   144,
       0,   337,     0,     0,  -181,     0,     0,   119,   120,   117,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   620,   621,     0,     0,     0,     0,
       0,     0,     0,   121,   122,     0,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,     0,   118,     0,     0,   141,   142,
       0,   143,     0,   144,     0,   587,   637,   638,   639,   640,
     641,   119,   120,   117,     0,   141,   142,     0,   143,     0,
     144,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   121,   122,     0,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,     0,   118,
       0,     0,   141,   142,     0,   143,     0,   144,     0,   594,
       0,     0,     0,     0,     0,   119,   120,   117,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   119,   120,     0,     0,     0,     0,     0,     0,
       0,   121,   122,     0,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,     0,   118,     0,     0,   141,   142,     0,   143,
     212,   144,   134,   135,   136,   137,   138,   139,   140,   119,
     120,   117,     0,   141,   142,     0,   143,     0,   144,     0,
       0,     0,     0,     0,     0,     0,   620,   621,     0,     0,
       0,     0,     0,     0,     0,   121,   122,     0,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,     0,   118,     0,     0,
     141,   142,     0,   143,   270,   144,   635,   636,   637,   638,
     639,   640,   641,   119,   120,   618,     0,   141,   142,     0,
     143,     0,   144,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   121,
     122,     0,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
       0,   619,     0,     0,   141,   142,     0,   143,   345,   144,
       0,     0,     0,     0,     0,     0,     0,   620,   621,   618,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,     0,     0,   622,   623,   372,   624,   625,   626,   627,
     628,   629,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,     0,   619,     0,     0,   141,   142,
       0,   143,     0,   144,     0,     0,     0,     0,     0,     0,
       0,   620,   621,   117,   703,   704,   286,   287,   705,   706,
     707,   708,   709,   293,   710,   711,   296,   712,   713,   299,
     300,   714,   302,   303,   304,     0,     0,   622,   623,    -7,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,     0,   118,
       0,     0,   141,   142,     0,   143,     0,   144,     0,     0,
       0,     0,     0,     0,     0,   119,   120,   117,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   121,   122,     0,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,     0,   118,     0,     0,   141,   142,     0,   143,
     414,   144,     0,     0,     0,     0,     0,     0,     0,   119,
     120,   117,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   121,   122,     0,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,     0,   118,     0,     0,
     141,   142,     0,   143,   422,   144,     0,     0,     0,     0,
       0,     0,     0,   119,   120,   117,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   121,
     122,     0,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
       0,   118,     0,     0,   141,   142,     0,   143,   524,   144,
       0,     0,     0,     0,     0,     0,     0,   119,   120,   117,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   121,   122,     0,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,     0,   118,     0,     0,   141,   142,
       0,   143,   578,   144,     0,     0,     0,     0,     0,     0,
       0,   119,   120,   117,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   121,   122,     0,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,     0,   118,
       0,     0,   141,   142,     0,   143,   580,   144,     0,     0,
       0,     0,     0,     0,     0,   119,   120,   618,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   121,   122,     0,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,     0,   619,     0,     0,   141,   142,     0,   143,
     599,   144,     0,     0,     0,     0,     0,     0,     0,   620,
     621,   117,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   622,   623,   693,   624,   625,
     626,   627,   628,   629,   630,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,     0,   118,     0,     0,
     141,   142,     0,   143,     0,   144,     0,     0,     0,     0,
       0,     0,     0,   119,   120,   117,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   121,
     122,     0,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
       0,   118,     0,     0,   141,   142,     0,   143,     0,   144,
       0,     0,     0,     0,     0,     0,     0,   119,   120,   618,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   121,   122,     0,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   132,   206,   134,   135,   136,
     137,   138,   139,   140,     0,   619,     0,     0,   141,   142,
       0,   143,     0,   144,     0,     0,     0,     0,     0,     0,
       0,   620,   621,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   622,   623,     0,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,    25,    26,
       0,     0,   141,   142,     0,   143,     0,   144,     0,     0,
       0,    27,     0,    28,    29,     0,     0,     0,     0,    30,
       0,     0,     0,     0,     0,     0,    25,    26,     0,    31,
       0,     0,     0,    32,    33,     0,     0,     0,    34,    27,
       0,    28,    29,     0,    35,   180,     0,    30,     0,     0,
       0,     6,     7,     8,     9,    10,     0,    31,     0,    11,
      12,    32,    33,     0,     0,     0,    34,     0,     0,    13,
      14,     0,    35,     0,    15,    16,    17,     0,     0,     0,
       0,     0,     0,    18,     0,     0,    36,     0,     0,    37,
      38,     0,    39,    19,    40,    41,    42,    43,    44,    45,
       0,    46,     0,     0,     0,    20,     0,   181,     0,     0,
       0,     0,     0,     0,    36,     0,     0,    37,    38,     0,
      39,     0,    40,    41,    42,    43,    44,    45,   113,    46,
      25,    26,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    27,     0,   607,    29,    25,    26,     0,
       0,   608,     0,     0,     0,     0,     0,     0,     0,     0,
      27,    31,    28,    29,     0,    32,   609,     0,    30,     0,
     610,     0,     0,     0,   531,     0,    35,     0,    31,    25,
      26,     0,    32,    33,     0,     0,     0,    34,     0,     0,
       0,     0,    27,    35,   607,    29,     0,     0,     0,     0,
     608,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      31,     0,   620,   621,    32,   609,     0,     0,    36,   610,
       0,   611,   612,     0,    39,    35,   613,   614,   615,   616,
     617,    45,     0,    46,     0,    36,     0,     0,    37,    38,
       0,    39,     0,    40,    41,    42,    43,    44,    45,     0,
      46,   634,   635,   636,   637,   638,   639,   640,   641,     0,
       0,     0,     0,   141,   142,     0,   143,    36,   144,     0,
     611,   612,     0,    39,     0,   613,   614,   615,   616,   617,
      45,     0,    46,   215,   216,     0,     0,     0,     0,     0,
     217,     0,     0,     0,     0,     0,     0,   218,     0,     0,
     219,     0,   220,   221,     0,     0,   222,     0,   223,     0,
     224,   225,     0,   226,   227,   228,     0,     0,     0,     0,
     229,   230,     0,     0,   231,     0,   232,     0,     0,     0,
       0,   233,   234,   235,     0,   236,   237,     0,   238,     0,
     239,   240,   215,   216,     0,     0,     0,     0,     0,   217,
       0,     0,     0,     0,     0,     0,   218,     0,     0,   219,
       0,   220,   221,     0,     0,   643,     0,   644,     0,   224,
     225,     0,   226,   227,   645,   119,   120,     0,     0,   229,
     230,     0,     0,   231,     0,   232,     0,     0,     0,     0,
     233,   234,   235,     0,   646,   237,     0,   238,     0,   239,
     647,     0,   122,     0,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,   620,   621,     0,     0,   141,   142,     0,   143,
       0,   144,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   623,
       0,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   119,
     120,     0,     0,   141,   142,     0,   143,     0,   144,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   620,   621,     0,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,     0,     0,     0,     0,
     141,   142,     0,   143,     0,   144,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   119,   120,     0,     0,   141,   142,     0,
     143,     0,   144,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   119,
     120,     0,     0,     0,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
       0,     0,     0,     0,   141,   142,     0,   143,     0,   144,
    -182,  -182,  -182,  -182,  -182,  -182,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   620,   621,     0,     0,
     141,   142,     0,   143,     0,   144,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   620,   621,     0,     0,     0,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,     0,     0,     0,     0,   141,   142,     0,
     143,     0,   144,  -182,  -182,  -182,  -182,  -182,  -182,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,     0,
       0,     0,     0,   141,   142,     0,   143,     0,   144
};

static const yytype_int16 yycheck[] =
{
       4,   103,   153,    24,    72,    91,   157,   306,   159,     3,
      78,   361,     4,   279,   364,    91,   369,   370,    45,   119,
     120,    91,   342,    33,    17,    91,    89,    91,    32,   349,
      20,   120,    36,    37,    38,   697,    40,    41,    42,    43,
     587,    45,    46,   119,   310,    14,    50,   594,   148,   315,
     151,    20,    91,    80,    55,    91,   126,   158,    50,    60,
     126,   125,    91,   164,    54,    66,    70,   174,   730,    73,
      91,   178,    99,    63,   181,    65,    80,    81,    82,    91,
     187,    86,   121,   119,   404,    92,    92,    92,    92,    91,
     119,   103,    96,    91,     0,    99,    94,   101,   120,   103,
      92,   103,   204,     7,     8,     9,    10,    11,   118,    66,
      67,   118,   118,   117,   118,   142,   109,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   140,   120,   142,    56,
     406,    33,    59,    91,    61,   124,    91,    66,    67,   415,
     107,   108,   109,   110,   111,   112,   125,    91,    66,    67,
     117,   118,   313,   120,    91,   122,   268,    94,    91,   170,
     120,   119,   176,   167,   119,   118,   177,    92,    95,    94,
      33,   185,   381,   382,   188,   119,   105,   106,   107,   108,
     109,   110,   111,   112,   120,   199,   119,    33,   117,   118,
     204,   120,   206,   122,   208,    33,   210,   120,   120,   117,
     118,   120,   120,   320,   122,   535,   316,   324,    33,   326,
     124,    94,   323,   325,   120,   376,   333,   378,    33,   336,
     331,     7,     8,     9,    10,    11,   126,    66,    67,    15,
      16,   126,   562,    94,   564,   162,    33,   398,   126,    25,
      26,   402,   403,   120,    30,    31,    32,   120,   126,    66,
      67,   329,   362,    39,   268,   365,    24,    25,   120,    92,
     120,   371,    18,    49,    92,   124,   596,    45,    33,   379,
     600,   110,   111,   112,    33,    61,   121,   121,   117,   118,
      48,   120,    12,   122,    33,    15,    16,    17,     4,    90,
     120,   452,   126,   110,   111,   112,   120,    90,    33,    91,
     117,   118,   121,   120,   308,   122,    44,   424,   121,    92,
     124,   325,   120,    41,   475,   120,    17,    18,   414,    41,
      41,   482,   685,   683,   420,   339,   422,   118,   124,    30,
     118,    32,    33,   494,    66,    67,   448,    38,    41,   125,
     124,    94,    94,   453,   121,    92,    92,    48,    92,    92,
      92,    52,    53,    92,   124,    92,    57,     4,   372,   373,
     121,    92,    63,   377,   121,    92,    92,    92,    92,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,    92,    33,   414,   125,   117,   118,   483,   120,   420,
     122,   422,   423,   503,    94,   426,    17,   411,   121,    33,
      33,   479,   119,   121,   105,   124,   715,   108,   109,   121,
     111,   448,   113,   114,   115,   116,   117,   118,   126,   120,
     126,   531,   121,   121,   125,   103,    23,    94,    59,   126,
     591,   592,   528,   126,   448,   126,   125,   554,   548,   125,
      33,    91,   559,   474,    17,    18,    41,   484,    91,   125,
      66,    67,   483,   125,   125,    33,   126,    30,   126,    32,
      33,   571,    92,    59,   125,    38,    94,   126,   103,    17,
     484,    61,    66,    67,    66,    48,    86,    17,    33,    52,
      53,   125,   120,   120,    57,   126,   126,    33,    41,    41,
      63,   107,   108,   109,   110,   111,   112,   528,   120,   118,
      41,   117,   118,    92,   120,    41,   122,   121,   121,   523,
     620,   621,   121,   527,   108,   109,   110,   111,   112,   373,
      92,    92,   536,   117,   118,    92,   120,    92,   122,    92,
     608,    92,    92,    92,   565,   549,    92,   652,    92,   651,
     113,   114,   115,   116,   156,    92,   560,    92,   716,   334,
     607,   543,   518,   584,   430,   586,    27,   470,   563,   346,
      64,    67,   201,    -1,    -1,   579,    -1,   568,    -1,   730,
     601,    -1,   682,   604,   684,    -1,   686,    -1,    -1,   691,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   611,   612,   613,
     614,   615,   616,    -1,   618,   619,    -1,   717,   622,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,    -1,    -1,
      -1,    -1,    -1,    -1,   648,   649,     3,   651,    -1,    -1,
       7,     8,     9,    10,    11,    -1,    13,    -1,    -1,    16,
      17,    18,    -1,    -1,    21,    -1,    -1,    -1,    25,    -1,
      27,    -1,    29,    30,    -1,    32,    33,    34,    -1,    -1,
      -1,    38,    -1,    40,    -1,   689,    -1,   691,   692,   693,
      47,    48,    -1,    -1,    51,    52,    53,    -1,    -1,    56,
      57,    -1,    -1,    -1,    -1,    -1,    63,    64,    65,    -1,
      -1,    -1,    -1,    -1,   718,   719,   720,   721,   722,   723,
     724,   725,   726,   727,   728,   729,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,     4,    -1,    -1,    -1,    -1,   105,    -1,
      -1,   108,   109,    -1,   111,    -1,   113,   114,   115,   116,
     117,   118,    -1,   120,    -1,    -1,     3,   124,   125,   126,
       7,     8,     9,    10,    11,    -1,    13,    -1,    -1,    16,
      17,    18,    -1,    -1,    21,    -1,    -1,    -1,    25,    50,
      27,    -1,    29,    30,    -1,    32,    33,    34,    -1,    -1,
      -1,    38,    -1,    40,    -1,    66,    67,    -1,    -1,    -1,
      47,    48,    -1,    -1,    51,    52,    53,    -1,    -1,    56,
      57,    -1,    -1,    -1,    -1,    -1,    63,    64,    65,    -1,
      -1,    92,    93,    -1,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,    -1,    -1,    -1,    -1,   117,   118,    -1,   120,
      -1,   122,    -1,     4,    -1,   126,    -1,    -1,   105,    -1,
      -1,   108,   109,    -1,   111,    -1,   113,   114,   115,   116,
     117,   118,    -1,   120,    -1,    -1,     3,   124,   125,   126,
       7,     8,     9,    10,    11,    -1,    13,    -1,    -1,    16,
      17,    18,    -1,    -1,    21,    -1,    -1,    -1,    25,    50,
      27,    -1,    29,    30,    -1,    32,    33,    34,    -1,    -1,
      -1,    38,    -1,    40,    -1,    66,    67,    -1,    -1,    -1,
      47,    48,    -1,    -1,    51,    52,    53,    -1,    -1,    56,
      57,    -1,    -1,    -1,    -1,    -1,    63,    64,    65,    -1,
      -1,    92,    93,    -1,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,    -1,    -1,    -1,    -1,   117,   118,    -1,   120,
      -1,   122,    -1,     4,    -1,   126,    -1,    -1,   105,    -1,
      -1,   108,   109,    -1,   111,    -1,   113,   114,   115,   116,
     117,   118,    -1,   120,    -1,    -1,     3,   124,   125,   126,
       7,     8,     9,    10,    11,    -1,    13,    -1,    -1,    16,
      17,    18,    -1,    -1,    21,    -1,    -1,    -1,    25,    50,
      27,    -1,    29,    30,    -1,    32,    33,    34,    -1,    -1,
      -1,    38,    -1,    40,    -1,    66,    67,     4,    -1,    -1,
      47,    48,    -1,    -1,    51,    52,    53,    -1,    -1,    56,
      57,    -1,    -1,    -1,    -1,    -1,    63,    64,    65,    -1,
      -1,    92,    93,    -1,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,    -1,    50,    -1,    -1,   117,   118,    -1,   120,
      -1,   122,    -1,    -1,    -1,   126,    -1,    -1,   105,    66,
      67,   108,   109,     4,   111,    -1,   113,   114,   115,   116,
     117,   118,    -1,   120,    -1,    -1,    -1,   124,    -1,   126,
      -1,    -1,    -1,    -1,    -1,    92,    93,    -1,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,    -1,    17,    18,    50,
     117,   118,    -1,   120,    -1,   122,    -1,    -1,    -1,   126,
      30,    -1,    32,    33,    -1,    66,    67,     4,    38,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    48,    -1,
      -1,    -1,    52,    53,    -1,    -1,    -1,    57,    -1,    -1,
      -1,    92,    93,    63,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,    -1,    50,    -1,    -1,   117,   118,    -1,   120,
      -1,   122,    -1,    -1,    -1,   126,    -1,    -1,    -1,    66,
      67,     4,    -1,    -1,    -1,   105,    -1,    -1,   108,   109,
      -1,   111,    -1,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,    -1,    -1,   124,    92,    93,    -1,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,    -1,    50,    -1,    -1,
     117,   118,    -1,   120,    -1,   122,    -1,   124,    -1,    -1,
      -1,    -1,    -1,    66,    67,     4,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    -1,    -1,    92,
      93,    -1,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
      -1,    50,    -1,    -1,   117,   118,    -1,   120,    -1,   122,
      -1,   124,    -1,    -1,   126,    -1,    -1,    66,    67,     4,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    66,    67,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    92,    93,    -1,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,    -1,    50,    -1,    -1,   117,   118,
      -1,   120,    -1,   122,    -1,   124,   108,   109,   110,   111,
     112,    66,    67,     4,    -1,   117,   118,    -1,   120,    -1,
     122,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    92,    93,    -1,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,    -1,    50,
      -1,    -1,   117,   118,    -1,   120,    -1,   122,    -1,   124,
      -1,    -1,    -1,    -1,    -1,    66,    67,     4,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    66,    67,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    92,    93,    -1,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,    -1,    50,    -1,    -1,   117,   118,    -1,   120,
     121,   122,   106,   107,   108,   109,   110,   111,   112,    66,
      67,     4,    -1,   117,   118,    -1,   120,    -1,   122,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    66,    67,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    92,    93,    -1,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,    -1,    50,    -1,    -1,
     117,   118,    -1,   120,   121,   122,   106,   107,   108,   109,
     110,   111,   112,    66,    67,     4,    -1,   117,   118,    -1,
     120,    -1,   122,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    92,
      93,    -1,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
      -1,    50,    -1,    -1,   117,   118,    -1,   120,   121,   122,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    66,    67,     4,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    -1,    -1,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,    -1,    50,    -1,    -1,   117,   118,
      -1,   120,    -1,   122,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    66,    67,     4,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    -1,    -1,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,    -1,    50,
      -1,    -1,   117,   118,    -1,   120,    -1,   122,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    66,    67,     4,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    92,    93,    -1,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,    -1,    50,    -1,    -1,   117,   118,    -1,   120,
     121,   122,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    66,
      67,     4,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    92,    93,    -1,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,    -1,    50,    -1,    -1,
     117,   118,    -1,   120,   121,   122,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    66,    67,     4,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    92,
      93,    -1,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
      -1,    50,    -1,    -1,   117,   118,    -1,   120,   121,   122,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    66,    67,     4,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    92,    93,    -1,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,    -1,    50,    -1,    -1,   117,   118,
      -1,   120,   121,   122,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    66,    67,     4,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    92,    93,    -1,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,    -1,    50,
      -1,    -1,   117,   118,    -1,   120,   121,   122,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    66,    67,     4,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    92,    93,    -1,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,    -1,    50,    -1,    -1,   117,   118,    -1,   120,
     121,   122,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    66,
      67,     4,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,    -1,    50,    -1,    -1,
     117,   118,    -1,   120,    -1,   122,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    66,    67,     4,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    92,
      93,    -1,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
      -1,    50,    -1,    -1,   117,   118,    -1,   120,    -1,   122,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    66,    67,     4,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    92,    93,    -1,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,    -1,    50,    -1,    -1,   117,   118,
      -1,   120,    -1,   122,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    66,    67,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    92,    93,    -1,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,    17,    18,
      -1,    -1,   117,   118,    -1,   120,    -1,   122,    -1,    -1,
      -1,    30,    -1,    32,    33,    -1,    -1,    -1,    -1,    38,
      -1,    -1,    -1,    -1,    -1,    -1,    17,    18,    -1,    48,
      -1,    -1,    -1,    52,    53,    -1,    -1,    -1,    57,    30,
      -1,    32,    33,    -1,    63,    64,    -1,    38,    -1,    -1,
      -1,     7,     8,     9,    10,    11,    -1,    48,    -1,    15,
      16,    52,    53,    -1,    -1,    -1,    57,    -1,    -1,    25,
      26,    -1,    63,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    -1,    -1,   105,    -1,    -1,   108,
     109,    -1,   111,    49,   113,   114,   115,   116,   117,   118,
      -1,   120,    -1,    -1,    -1,    61,    -1,   126,    -1,    -1,
      -1,    -1,    -1,    -1,   105,    -1,    -1,   108,   109,    -1,
     111,    -1,   113,   114,   115,   116,   117,   118,   119,   120,
      17,    18,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    30,    -1,    32,    33,    17,    18,    -1,
      -1,    38,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      30,    48,    32,    33,    -1,    52,    53,    -1,    38,    -1,
      57,    -1,    -1,    -1,    61,    -1,    63,    -1,    48,    17,
      18,    -1,    52,    53,    -1,    -1,    -1,    57,    -1,    -1,
      -1,    -1,    30,    63,    32,    33,    -1,    -1,    -1,    -1,
      38,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      48,    -1,    66,    67,    52,    53,    -1,    -1,   105,    57,
      -1,   108,   109,    -1,   111,    63,   113,   114,   115,   116,
     117,   118,    -1,   120,    -1,   105,    -1,    -1,   108,   109,
      -1,   111,    -1,   113,   114,   115,   116,   117,   118,    -1,
     120,   105,   106,   107,   108,   109,   110,   111,   112,    -1,
      -1,    -1,    -1,   117,   118,    -1,   120,   105,   122,    -1,
     108,   109,    -1,   111,    -1,   113,   114,   115,   116,   117,
     118,    -1,   120,     5,     6,    -1,    -1,    -1,    -1,    -1,
      12,    -1,    -1,    -1,    -1,    -1,    -1,    19,    -1,    -1,
      22,    -1,    24,    25,    -1,    -1,    28,    -1,    30,    -1,
      32,    33,    -1,    35,    36,    37,    -1,    -1,    -1,    -1,
      42,    43,    -1,    -1,    46,    -1,    48,    -1,    -1,    -1,
      -1,    53,    54,    55,    -1,    57,    58,    -1,    60,    -1,
      62,    63,     5,     6,    -1,    -1,    -1,    -1,    -1,    12,
      -1,    -1,    -1,    -1,    -1,    -1,    19,    -1,    -1,    22,
      -1,    24,    25,    -1,    -1,    28,    -1,    30,    -1,    32,
      33,    -1,    35,    36,    37,    66,    67,    -1,    -1,    42,
      43,    -1,    -1,    46,    -1,    48,    -1,    -1,    -1,    -1,
      53,    54,    55,    -1,    57,    58,    -1,    60,    -1,    62,
      63,    -1,    93,    -1,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,    66,    67,    -1,    -1,   117,   118,    -1,   120,
      -1,   122,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    93,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,    66,
      67,    -1,    -1,   117,   118,    -1,   120,    -1,   122,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    66,    67,    -1,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,    -1,    -1,    -1,    -1,
     117,   118,    -1,   120,    -1,   122,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,    66,    67,    -1,    -1,   117,   118,    -1,
     120,    -1,   122,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    66,
      67,    -1,    -1,    -1,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
      -1,    -1,    -1,    -1,   117,   118,    -1,   120,    -1,   122,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,    66,    67,    -1,    -1,
     117,   118,    -1,   120,    -1,   122,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    66,    67,    -1,    -1,    -1,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,    -1,    -1,    -1,    -1,   117,   118,    -1,
     120,    -1,   122,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,    -1,
      -1,    -1,    -1,   117,   118,    -1,   120,    -1,   122
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,    89,   128,   130,   129,     0,     7,     8,     9,    10,
      11,    15,    16,    25,    26,    30,    31,    32,    39,    49,
      61,   158,   167,   168,   194,    17,    18,    30,    32,    33,
      38,    48,    52,    53,    57,    63,   105,   108,   109,   111,
     113,   114,   115,   116,   117,   118,   120,   135,   175,   188,
     120,   120,   120,   205,   206,   205,   208,   209,   124,   205,
     205,   205,    33,    24,    25,    48,   203,   204,   203,   165,
       3,    13,    16,    21,    25,    27,    29,    34,    38,    40,
      47,    51,    56,    64,    65,   124,   126,   135,   167,   188,
     192,   200,   120,   118,   176,   177,   141,    33,   202,   120,
     135,   120,   120,   120,   135,   135,   135,   142,   135,   135,
     135,   135,    33,   119,   135,   143,   135,     4,    50,    66,
      67,    92,    93,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   117,   118,   120,   122,   135,    33,    33,    94,   182,
     203,   182,   120,   181,    33,   210,   159,   181,   182,   181,
     126,   203,   208,   203,   182,   210,    94,   166,   135,   126,
     202,   135,    33,   195,   126,   120,   120,   202,   126,   143,
      64,   126,   135,   135,   120,   120,   193,   126,    92,   192,
     135,    18,   178,   179,   180,   124,   172,   181,   135,    92,
     143,   124,   143,   144,   137,   144,   105,    45,    92,   176,
      91,   119,   121,   135,   135,     5,     6,    12,    19,    22,
      24,    25,    28,    30,    32,    33,    35,    36,    37,    42,
      43,    46,    48,    53,    54,    55,    57,    58,    60,    62,
      63,   148,   211,   148,   135,   135,   135,   135,   135,   135,
     135,   135,   135,   135,   135,   135,   135,   135,   135,   135,
     135,   135,   135,   135,    33,   131,   135,   143,   139,    33,
     121,   121,   121,   148,     4,    50,    92,   183,   207,   183,
      33,   155,   156,   157,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,   189,   190,   191,   130,   189,
     183,   189,     4,   181,   161,   183,   164,   124,   167,   169,
     126,    90,   212,   182,   126,   120,   126,   212,    33,   118,
     135,   182,   212,   126,   120,   212,   126,   124,   132,   133,
     135,    90,   213,   212,   135,   121,    91,   119,    33,   173,
     135,   121,   195,   121,   144,   121,    44,   135,    92,   135,
     124,   120,    41,   181,   120,    41,    41,   124,   118,   118,
     124,    41,    94,    94,   119,   144,   184,   185,   184,    94,
     121,    91,   126,    92,    92,    92,    92,    92,    92,    92,
      92,    92,    92,    92,    92,    92,   191,   125,   184,   124,
     189,     4,   184,   148,   170,   212,   183,   212,   144,   212,
      91,   103,   201,   202,   121,   183,   212,   132,   212,   196,
     121,   135,   121,   194,   126,   179,   194,   125,   189,   121,
     136,   151,   155,   148,   155,   148,    33,   149,   148,   152,
     152,   152,   148,   135,   131,   135,   140,   189,   124,   135,
     187,   189,   148,    94,   157,   157,   135,   135,   135,   135,
     135,   135,   135,   135,   135,   135,   135,   135,    17,   189,
     160,   124,   189,   189,   194,   184,   121,    33,   135,    91,
     119,   192,   184,   121,    14,    20,   125,   197,   192,   134,
     192,   125,   212,   174,   138,   172,    33,   145,   146,   147,
     121,   121,   153,    91,   119,   119,   125,   119,   121,   126,
     143,   144,   186,   126,   189,   148,   126,   145,   162,   126,
     126,   171,   189,   103,   121,   202,    91,   103,    23,   189,
     192,    61,   143,   198,   199,    94,    59,   125,   189,    86,
      92,   214,   125,    91,    33,   150,   154,   148,    41,    91,
     125,   125,   153,   125,   126,   135,    33,   135,   192,   126,
      59,   148,    94,    91,    94,   194,   135,    92,    17,   109,
     147,    94,   125,   148,   125,   126,   163,   212,   121,   103,
     121,   212,   135,    66,   194,   199,   194,   124,    17,   214,
      17,   148,   125,   135,   124,    33,   213,   189,   189,   121,
     213,   194,   126,   126,   194,   125,   125,    32,    38,    53,
      57,   108,   109,   113,   114,   115,   116,   117,     4,    50,
      66,    67,    92,    93,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   135,    28,    30,    37,    57,    63,    91,   141,
     202,   120,   120,   135,   135,   135,   135,   135,   135,    33,
     135,   135,   135,   135,   135,   135,   135,   135,   135,   135,
     135,   135,   135,   135,   135,   135,   135,   135,   135,   135,
     135,   135,    41,   120,    41,   118,    41,   135,   135,    92,
     144,   137,    92,    94,   155,   152,   135,   121,   144,   135,
     135,   121,   119,    68,    69,    72,    73,    74,    75,    76,
      78,    79,    81,    82,    85,   190,   121,    41,    92,    92,
      92,    92,    92,    92,    92,    92,    92,    92,    92,    92,
     138,   135,   135,   135,   135,   135,   135,   135,   135,   135,
     135,   135,   135
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,   127,   128,   129,   128,   130,   130,   131,   131,   133,
     134,   132,   135,   135,   135,   135,   135,   135,   135,   135,
     135,   135,   135,   135,   135,   135,   135,   135,   135,   135,
     135,   135,   135,   135,   135,   135,   135,   135,   135,   135,
     135,   135,   135,   135,   135,   136,   135,   135,   135,   135,
     135,   135,   137,   138,   135,   135,   135,   139,   140,   135,
     141,   135,   135,   135,   135,   135,   135,   142,   135,   135,
     135,   135,   143,   143,   144,   144,   145,   145,   146,   146,
     147,   147,   147,   148,   148,   148,   148,   148,   148,   148,
     148,   148,   148,   148,   148,   148,   148,   148,   149,   150,
     148,   148,   151,   148,   148,   148,   148,   148,   148,   148,
     148,   148,   148,   148,   152,   152,   153,   153,   154,   155,
     155,   155,   156,   156,   156,   157,   158,   159,   158,   158,
     158,   158,   158,   160,   158,   161,   162,   163,   158,   164,
     158,   165,   158,   158,   166,   166,   167,   167,   167,   167,
     167,   168,   168,   168,   168,   170,   171,   169,   173,   174,
     172,   175,   176,   177,   177,   178,   178,   179,   180,   180,
     181,   181,   182,   182,   183,   183,   183,   183,   185,   186,
     184,   184,   187,   187,   187,   188,   189,   189,   190,   190,
     191,   191,   191,   191,   191,   191,   191,   191,   191,   191,
     191,   191,   191,   191,   191,   191,   191,   191,   191,   191,
     191,   191,   193,   192,   192,   192,   192,   192,   192,   192,
     192,   192,   192,   192,   192,   192,   192,   192,   192,   192,
     192,   192,   192,   192,   192,   192,   192,   192,   194,   194,
     195,   196,   196,   197,   197,   197,   198,   198,   199,   199,
     200,   200,   200,   200,   201,   201,   202,   204,   203,   206,
     207,   205,   209,   208,   210,   211,   212,   212,   213,   213,
     214,   214,   214
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     2,     0,     3,     2,     0,     1,     0,     0,
       0,     3,     3,     4,     2,     2,     2,     2,     2,     2,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     5,     3,
       4,     4,     1,     3,     4,     0,     6,     3,     3,     3,
       2,     4,     0,     0,     7,     5,     4,     0,     0,     6,
       0,     3,     3,     1,     5,     1,     1,     0,     4,     3,
       3,     3,     3,     1,     1,     0,     1,     2,     1,     3,
       4,     4,     2,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     6,     4,     0,     0,
       6,     4,     0,     5,     1,     3,     3,     2,     4,     4,
       3,     1,     3,     1,     3,     1,     2,     0,     5,     1,
       2,     0,     3,     3,     1,     4,     3,     0,     5,     7,
       7,     7,     7,     0,     9,     0,     0,     0,    12,     0,
       7,     0,     4,     1,     0,     2,     4,     4,     4,     1,
       1,     4,     4,     4,     5,     0,     0,     5,     0,     0,
       5,     3,     2,     3,     0,     3,     1,     2,     1,     0,
       5,     3,     2,     0,     0,     1,     1,     1,     0,     0,
       3,     0,     3,     4,     1,     6,     1,     0,     2,     1,
       3,     1,     1,     1,     1,     3,     3,     3,     3,     1,
       3,     3,     3,     3,     3,     1,     3,     3,     1,     1,
       1,     3,     0,     5,     4,     4,     5,     7,     5,     2,
       5,     3,     3,     3,     3,     4,     4,     4,     8,     8,
       5,    11,     6,    12,     5,     3,     1,     1,     2,     0,
       4,     2,     0,     4,     4,     3,     3,     1,     2,     4,
       6,     8,     8,    10,     3,     1,     1,     0,     2,     0,
       0,     3,     0,     2,     1,     1,     1,     0,     1,     0,
       1,     3,     0
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (0)
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL

/* Print *YYLOCP on YYO.  Private, do not rely on its existence. */

YY_ATTRIBUTE_UNUSED
static unsigned
yy_location_print_ (FILE *yyo, YYLTYPE const * const yylocp)
{
  unsigned res = 0;
  int end_col = 0 != yylocp->last_column ? yylocp->last_column - 1 : 0;
  if (0 <= yylocp->first_line)
    {
      res += YYFPRINTF (yyo, "%d", yylocp->first_line);
      if (0 <= yylocp->first_column)
        res += YYFPRINTF (yyo, ".%d", yylocp->first_column);
    }
  if (0 <= yylocp->last_line)
    {
      if (yylocp->first_line < yylocp->last_line)
        {
          res += YYFPRINTF (yyo, "-%d", yylocp->last_line);
          if (0 <= end_col)
            res += YYFPRINTF (yyo, ".%d", end_col);
        }
      else if (0 <= end_col && yylocp->first_column < end_col)
        res += YYFPRINTF (yyo, "-%d", end_col);
    }
  return res;
 }

#  define YY_LOCATION_PRINT(File, Loc)          \
  yy_location_print_ (File, &(Loc))

# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value, Location); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  YYUSE (yylocationp);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  YY_LOCATION_PRINT (yyoutput, *yylocationp);
  YYFPRINTF (yyoutput, ": ");
  yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, YYLTYPE *yylsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                       , &(yylsp[(yyi + 1) - (yynrhs)])                       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, yylsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, YYLTYPE *yylocationp)
{
  YYUSE (yyvaluep);
  YYUSE (yylocationp);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Location data for the lookahead symbol.  */
YYLTYPE yylloc
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  = { 1, 1, 1, 1 }
# endif
;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.
       'yyls': related to locations.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    /* The location stack.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls;
    YYLTYPE *yylsp;

    /* The locations where the error started and ended.  */
    YYLTYPE yyerror_range[3];

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yylsp = yyls = yylsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  yylsp[0] = yylloc;
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;
        YYLTYPE *yyls1 = yyls;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yyls1, yysize * sizeof (*yylsp),
                    &yystacksize);

        yyls = yyls1;
        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
        YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END
  *++yylsp = yylloc;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location.  */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 319 "parse.y" /* yacc.c:1646  */
    {
			if ( stmts )
				stmts->AsStmtList()->Stmts().push_back((yyvsp[0].stmt));
			else
				stmts = (yyvsp[0].stmt);

			// Any objects creates from here on out should not
			// have file positions associated with them.
			set_location(no_location);
			}
#line 2655 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 3:
#line 333 "parse.y" /* yacc.c:1646  */
    { in_debug = true; }
#line 2661 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 4:
#line 334 "parse.y" /* yacc.c:1646  */
    {
			g_curr_debug_expr = (yyvsp[0].expr);
			}
#line 2669 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 7:
#line 346 "parse.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[0].expr); }
#line 2675 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 8:
#line 348 "parse.y" /* yacc.c:1646  */
    { (yyval.expr) = 0; }
#line 2681 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 9:
#line 352 "parse.y" /* yacc.c:1646  */
    { ++in_when_cond; }
#line 2687 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 10:
#line 352 "parse.y" /* yacc.c:1646  */
    { --in_when_cond; }
#line 2693 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 11:
#line 353 "parse.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[-1].expr); }
#line 2699 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 12:
#line 358 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = (yyvsp[-1].expr); (yyval.expr)->MarkParen();
			}
#line 2708 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 13:
#line 364 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-3]), (yylsp[0]));
			(yyval.expr) = new CloneExpr({AdoptRef{}, (yyvsp[-1].expr)});
			}
#line 2717 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 14:
#line 370 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-1]), (yylsp[0]));
			(yyval.expr) = new IncrExpr(EXPR_INCR, {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 2726 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 15:
#line 376 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-1]), (yylsp[0]));
			(yyval.expr) = new IncrExpr(EXPR_DECR, {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 2735 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 16:
#line 382 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-1]), (yylsp[0]));
			(yyval.expr) = new NotExpr({AdoptRef{}, (yyvsp[0].expr)});
			}
#line 2744 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 17:
#line 388 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-1]), (yylsp[0]));
			(yyval.expr) = new ComplementExpr({AdoptRef{}, (yyvsp[0].expr)});
			}
#line 2753 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 18:
#line 394 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-1]), (yylsp[0]));
			(yyval.expr) = new NegExpr({AdoptRef{}, (yyvsp[0].expr)});

			if ( ! (yyval.expr)->IsError() && (yyvsp[0].expr)->IsConst() )
				{
				auto v = (yyvsp[0].expr)->ExprVal();
				auto tag = v->GetType()->Tag();

				if ( tag == TYPE_COUNT )
					{
					auto c = v->AsCount();
					uint64_t int_max = static_cast<uint64_t>(INT64_MAX) + 1;

					if ( c <= int_max )
						{
						auto ce = new ConstExpr(val_mgr->Int(-c));
						Unref((yyval.expr));
						(yyval.expr) = ce;
						}
					else
						{
						(yyval.expr)->Error("literal is outside range of 'int' values");
						(yyval.expr)->SetError();
						}
					}
				else
					{
					auto ce = new ConstExpr((yyval.expr)->Eval(nullptr));
					Unref((yyval.expr));
					(yyval.expr) = ce;
					}
				}
			}
#line 2792 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 19:
#line 430 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-1]), (yylsp[0]));
			(yyval.expr) = new PosExpr({AdoptRef{}, (yyvsp[0].expr)});
			}
#line 2801 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 20:
#line 436 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new AddExpr({AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 2810 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 21:
#line 442 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new AddToExpr({AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 2819 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 22:
#line 448 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new SubExpr({AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 2828 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 23:
#line 454 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new RemoveFromExpr({AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 2837 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 24:
#line 460 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new TimesExpr({AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 2846 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 25:
#line 466 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new DivideExpr({AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 2855 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 26:
#line 472 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new ModExpr({AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 2864 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 27:
#line 478 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new BitExpr(EXPR_AND, {AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 2873 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 28:
#line 484 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new BitExpr(EXPR_OR, {AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 2882 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 29:
#line 490 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new BitExpr(EXPR_XOR, {AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 2891 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 30:
#line 496 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new BoolExpr(EXPR_AND_AND, {AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 2900 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 31:
#line 502 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new BoolExpr(EXPR_OR_OR, {AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 2909 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 32:
#line 508 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new EqExpr(EXPR_EQ, {AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 2918 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 33:
#line 514 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new EqExpr(EXPR_NE, {AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 2927 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 34:
#line 520 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new RelExpr(EXPR_LT, {AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 2936 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 35:
#line 526 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new RelExpr(EXPR_LE, {AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 2945 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 36:
#line 532 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new RelExpr(EXPR_GT, {AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 2954 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 37:
#line 538 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new RelExpr(EXPR_GE, {AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 2963 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 38:
#line 544 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-4]), (yylsp[0]));
			(yyval.expr) = new CondExpr({AdoptRef{}, (yyvsp[-4].expr)}, {AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 2972 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 39:
#line 550 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));

			if ( (yyvsp[-2].expr)->Tag() == EXPR_INDEX && (yyvsp[-2].expr)->AsIndexExpr()->IsSlice() )
				reporter->Error("index slice assignment may not be used"
				                      " in arbitrary expression contexts, only"
				                      " as a statement");

			(yyval.expr) = get_assign_expr({AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].expr)}, in_init).release();
			}
#line 2987 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 40:
#line 562 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			if ( ! locals_at_this_scope.empty() )
			       locals_at_this_scope.back().insert((yyvsp[-2].id));
			(yyval.expr) = add_and_assign_local({AdoptRef{}, (yyvsp[-2].id)}, {AdoptRef{}, (yyvsp[0].expr)},
			                                        val_mgr->True()).release();
			}
#line 2999 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 41:
#line 571 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-3]), (yylsp[0]));
			if ( in_when_cond > 0 )
				(yyval.expr) = new IndexExprWhen({AdoptRef{}, (yyvsp[-3].expr)}, {AdoptRef{}, (yyvsp[-1].list)});
			else
				(yyval.expr) = new IndexExpr({AdoptRef{}, (yyvsp[-3].expr)}, {AdoptRef{}, (yyvsp[-1].list)});
			}
#line 3011 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 43:
#line 582 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new FieldExpr({AdoptRef{}, (yyvsp[-2].expr)}, (yyvsp[0].str));
			}
#line 3020 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 44:
#line 588 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-3]), (yylsp[0]));
			(yyval.expr) = new FieldAssignExpr((yyvsp[-2].str), {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 3029 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 45:
#line 594 "parse.y" /* yacc.c:1646  */
    {
			func_hdr_location = (yylsp[-3]);
			(yyvsp[-1].id)->SetInferReturnType(true);
			}
#line 3038 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 46:
#line 599 "parse.y" /* yacc.c:1646  */
    {
			(yyval.expr) = new FieldAssignExpr((yyvsp[-4].str), IntrusivePtr{AdoptRef{}, (yyvsp[0].expr)});
			}
#line 3046 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 47:
#line 604 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new InExpr({AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 3055 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 48:
#line 610 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new NotExpr(make_intrusive<InExpr>(
			        ExprPtr{AdoptRef{}, (yyvsp[-2].expr)},
			        ExprPtr{AdoptRef{}, (yyvsp[0].expr)}));
			}
#line 3066 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 49:
#line 618 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));

			bool is_record_ctor = true;

			// If every expression in the list is a field assignment,
			// then treat it as a record constructor, else as a list
			// used for an initializer.

			for ( int i = 0; i < (yyvsp[-1].list)->Exprs().length(); ++i )
				{
				if ( (yyvsp[-1].list)->Exprs()[i]->Tag() != EXPR_FIELD_ASSIGN )
					{
					is_record_ctor = false;
					break;
					}
				}

			if ( is_record_ctor )
				(yyval.expr) = new RecordConstructorExpr({AdoptRef{}, (yyvsp[-1].list)});
			else
				(yyval.expr) = (yyvsp[-1].list);
			}
#line 3094 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 50:
#line 643 "parse.y" /* yacc.c:1646  */
    {
			// We interpret this as an empty record constructor.
			(yyval.expr) = new RecordConstructorExpr(make_intrusive<ListExpr>());
			}
#line 3103 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 51:
#line 650 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-3]), (yylsp[0]));
			(yyval.expr) = new RecordConstructorExpr({AdoptRef{}, (yyvsp[-1].list)});
			}
#line 3112 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 52:
#line 655 "parse.y" /* yacc.c:1646  */
    { ++in_init; }
#line 3118 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 53:
#line 655 "parse.y" /* yacc.c:1646  */
    { --in_init; }
#line 3124 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 54:
#line 657 "parse.y" /* yacc.c:1646  */
    { // the ++in_init fixes up the parsing of "[x] = y"
			set_location((yylsp[-6]), (yylsp[-2]));
			std::unique_ptr<std::vector<AttrPtr>> attrs{(yyvsp[0].attr_l)};
			(yyval.expr) = new TableConstructorExpr({AdoptRef{}, (yyvsp[-3].list)}, std::move(attrs));
			}
#line 3134 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 55:
#line 664 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-4]), (yylsp[-1]));
			std::unique_ptr<std::vector<AttrPtr>> attrs{(yyvsp[0].attr_l)};
			(yyval.expr) = new SetConstructorExpr({AdoptRef{}, (yyvsp[-2].list)}, std::move(attrs));
			}
#line 3144 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 56:
#line 671 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-3]), (yylsp[0]));
			(yyval.expr) = new VectorConstructorExpr({AdoptRef{}, (yyvsp[-1].list)});
			}
#line 3153 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 57:
#line 677 "parse.y" /* yacc.c:1646  */
    {
			if ( expr_is_table_type_name((yyvsp[-1].expr)) )
				++in_init;
			}
#line 3162 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 58:
#line 683 "parse.y" /* yacc.c:1646  */
    {
			if ( expr_is_table_type_name((yyvsp[-3].expr)) )
				--in_init;
			}
#line 3171 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 59:
#line 689 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-5]), (yylsp[0]));

			if ( (yyvsp[-5].expr)->Tag() == EXPR_NAME && (yyvsp[-5].expr)->AsNameExpr()->Id()->IsType() )
				{
				const auto& ctor_type = (yyvsp[-5].expr)->AsNameExpr()->Id()->GetType();

				switch ( ctor_type->Tag() ) {
				case TYPE_RECORD:
					{
					auto rt = cast_intrusive<RecordType>(ctor_type);
					(yyval.expr) = new RecordConstructorExpr(rt, ListExprPtr{AdoptRef{}, (yyvsp[-2].list)});
					}
					break;

				case TYPE_TABLE:
					if ( ctor_type->IsTable() )
						(yyval.expr) = new TableConstructorExpr({AdoptRef{}, (yyvsp[-2].list)}, 0, ctor_type);
					else
						(yyval.expr) = new SetConstructorExpr({AdoptRef{}, (yyvsp[-2].list)}, 0, ctor_type);

					break;

				case TYPE_VECTOR:
					(yyval.expr) = new VectorConstructorExpr({AdoptRef{}, (yyvsp[-2].list)}, ctor_type);
					break;

				default:
					(yyvsp[-5].expr)->Error("constructor type not implemented");
					YYERROR;
				}
				}

			else
				(yyval.expr) = new CallExpr({AdoptRef{}, (yyvsp[-5].expr)}, {AdoptRef{}, (yyvsp[-2].list)}, in_hook > 0);
			}
#line 3212 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 60:
#line 726 "parse.y" /* yacc.c:1646  */
    { ++in_hook; }
#line 3218 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 61:
#line 727 "parse.y" /* yacc.c:1646  */
    {
			--in_hook;
			set_location((yylsp[-2]), (yylsp[0]));

			if ( (yyvsp[0].expr)->Tag() != EXPR_CALL )
				(yyvsp[0].expr)->Error("not a valid hook call expression");
			else if ( (yyvsp[0].expr)->AsCallExpr()->Func()->GetType()->AsFuncType()->Flavor() != FUNC_FLAVOR_HOOK )
				(yyvsp[0].expr)->Error("hook keyword should only be used to call hooks");

			(yyval.expr) = (yyvsp[0].expr);
			}
#line 3234 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 62:
#line 740 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new HasFieldExpr({AdoptRef{}, (yyvsp[-2].expr)}, (yyvsp[0].str));
			}
#line 3243 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 64:
#line 749 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-4]), (yylsp[0]));
			(yyval.expr) = new ScheduleExpr({AdoptRef{}, (yyvsp[-3].expr)}, {AdoptRef{}, (yyvsp[-1].event_expr)});
			}
#line 3252 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 65:
#line 755 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[0]));
			auto id = lookup_ID((yyvsp[0].str), current_module.c_str());

			if ( ! id )
				{
				if ( ! in_debug )
					{
/*	// CHECK THAT THIS IS NOT GLOBAL.
					id = install_ID($1, current_module.c_str(),
							        false, is_export);
*/

					yyerror(util::fmt("unknown identifier %s", (yyvsp[0].str)));
					YYERROR;
					}
				else
					{
					yyerror(util::fmt("unknown identifier %s", (yyvsp[0].str)));
					YYERROR;
					}
				}
			else
				{
				if ( id->IsDeprecated() )
					reporter->Warning("%s", id->GetDeprecationWarning().c_str());

				if ( ! id->GetType() )
					{
					id->Error("undeclared variable");
					id->SetType(error_type());
					(yyval.expr) = new NameExpr(std::move(id));
					}

				else if ( id->IsEnumConst() )
					{
					if ( IsErrorType(id->GetType()->Tag()) )
						{
						// The most-relevant error message should already be reported, so
						// just bail out.
						YYERROR;
						}

					EnumType* t = id->GetType()->AsEnumType();
					auto intval = t->Lookup(id->ModuleName(), id->Name());
					if ( intval < 0 )
						reporter->InternalError("enum value not found for %s", id->Name());
					(yyval.expr) = new ConstExpr(t->GetEnumVal(intval));
					}
				else
					{
					if ( out_of_scope_locals.count(id.get()) > 0 &&
					     warned_about_locals.count(id.get()) == 0 )
						{
						// Remove in v5.1
						reporter->Warning("use of out-of-scope local %s deprecated; move declaration to outer scope", id->Name());
						warned_about_locals.insert(id.get());
						}

					(yyval.expr) = new NameExpr(std::move(id));
					}
				}
			}
#line 3320 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 66:
#line 820 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[0]));
			(yyval.expr) = new ConstExpr({AdoptRef{}, (yyvsp[0].val)});
			}
#line 3329 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 67:
#line 825 "parse.y" /* yacc.c:1646  */
    { begin_RE(); }
#line 3335 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 68:
#line 826 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-1]));

			auto* re = new RE_Matcher((yyvsp[-1].str));
			delete [] (yyvsp[-1].str);

			if ( (yyvsp[0].b) )
				re->MakeCaseInsensitive();

			re->Compile();
			(yyval.expr) = new ConstExpr(make_intrusive<PatternVal>(re));
			}
#line 3352 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 69:
#line 840 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			ExprPtr e{AdoptRef{}, (yyvsp[-1].expr)};
			(yyval.expr) = new SizeExpr(std::move(e));
			}
#line 3362 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 70:
#line 847 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new CastExpr({AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].type)});
			}
#line 3371 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 71:
#line 853 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new IsExpr({AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].type)});
			}
#line 3380 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 72:
#line 861 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyvsp[-2].list)->Append({AdoptRef{}, (yyvsp[0].expr)});
			}
#line 3389 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 73:
#line 867 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[0]));
			(yyval.list) = new ListExpr({AdoptRef{}, (yyvsp[0].expr)});
			}
#line 3398 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 75:
#line 876 "parse.y" /* yacc.c:1646  */
    { (yyval.list) = new ListExpr(); }
#line 3404 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 76:
#line 881 "parse.y" /* yacc.c:1646  */
    {
			(yyval.type) = cur_enum_type;
			cur_enum_type = nullptr;
			}
#line 3413 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 77:
#line 887 "parse.y" /* yacc.c:1646  */
    {
			(yyval.type) = cur_enum_type;
			cur_enum_type = nullptr;
			}
#line 3422 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 80:
#line 906 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-3]), (yylsp[-1]));
			assert(cur_enum_type);

			if ( (yyvsp[-1].val)->GetType()->Tag() != TYPE_COUNT )
				reporter->Error("enumerator is not a count constant");
			else
				cur_enum_type->AddName(current_module, (yyvsp[-3].str),
				                       (yyvsp[-1].val)->InternalUnsigned(), is_export, (yyvsp[0].expr),
				                       in_enum_redef != 0);
			}
#line 3438 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 81:
#line 919 "parse.y" /* yacc.c:1646  */
    {
			// We only accept counts as enumerator, but we want to return a nice
			// error message if users triy to use a negative integer (will also
			// catch other cases, but that's fine.)
			reporter->Error("enumerator is not a count constant");
			}
#line 3449 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 82:
#line 927 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-1]));
			assert(cur_enum_type);
			cur_enum_type->AddName(current_module, (yyvsp[-1].str), is_export, (yyvsp[0].expr),
			                       in_enum_redef != 0);
			}
#line 3460 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 83:
#line 936 "parse.y" /* yacc.c:1646  */
    {
				set_location((yylsp[0]));
				(yyval.type) = base_type(TYPE_BOOL)->Ref();
				}
#line 3469 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 84:
#line 941 "parse.y" /* yacc.c:1646  */
    {
				set_location((yylsp[0]));
				(yyval.type) = base_type(TYPE_INT)->Ref();
				}
#line 3478 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 85:
#line 946 "parse.y" /* yacc.c:1646  */
    {
				set_location((yylsp[0]));
				(yyval.type) = base_type(TYPE_COUNT)->Ref();
				}
#line 3487 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 86:
#line 951 "parse.y" /* yacc.c:1646  */
    {
				set_location((yylsp[0]));
				(yyval.type) = base_type(TYPE_DOUBLE)->Ref();
				}
#line 3496 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 87:
#line 956 "parse.y" /* yacc.c:1646  */
    {
				set_location((yylsp[0]));
				(yyval.type) = base_type(TYPE_TIME)->Ref();
				}
#line 3505 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 88:
#line 961 "parse.y" /* yacc.c:1646  */
    {
				set_location((yylsp[0]));
				(yyval.type) = base_type(TYPE_INTERVAL)->Ref();
				}
#line 3514 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 89:
#line 966 "parse.y" /* yacc.c:1646  */
    {
				set_location((yylsp[0]));
				(yyval.type) = base_type(TYPE_STRING)->Ref();
				}
#line 3523 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 90:
#line 971 "parse.y" /* yacc.c:1646  */
    {
				set_location((yylsp[0]));
				(yyval.type) = base_type(TYPE_PATTERN)->Ref();
				}
#line 3532 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 91:
#line 976 "parse.y" /* yacc.c:1646  */
    {
				set_location((yylsp[0]));
				(yyval.type) = base_type(TYPE_TIMER)->Ref();
				}
#line 3541 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 92:
#line 981 "parse.y" /* yacc.c:1646  */
    {
				set_location((yylsp[0]));
				(yyval.type) = base_type(TYPE_PORT)->Ref();
				}
#line 3550 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 93:
#line 986 "parse.y" /* yacc.c:1646  */
    {
				set_location((yylsp[0]));
				(yyval.type) = base_type(TYPE_ADDR)->Ref();
				}
#line 3559 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 94:
#line 991 "parse.y" /* yacc.c:1646  */
    {
				set_location((yylsp[0]));
				(yyval.type) = base_type(TYPE_SUBNET)->Ref();
				}
#line 3568 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 95:
#line 996 "parse.y" /* yacc.c:1646  */
    {
				set_location((yylsp[0]));
				(yyval.type) = base_type(TYPE_ANY)->Ref();
				}
#line 3577 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 96:
#line 1002 "parse.y" /* yacc.c:1646  */
    {
				set_location((yylsp[-5]), (yylsp[0]));
				(yyval.type) = new TableType({AdoptRef{}, (yyvsp[-3].type_l)}, {AdoptRef{}, (yyvsp[0].type)});
				}
#line 3586 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 97:
#line 1008 "parse.y" /* yacc.c:1646  */
    {
				set_location((yylsp[-3]), (yylsp[0]));
				(yyval.type) = new SetType({AdoptRef{}, (yyvsp[-1].type_l)}, nullptr);
				}
#line 3595 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 98:
#line 1014 "parse.y" /* yacc.c:1646  */
    { ++in_record; }
#line 3601 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 99:
#line 1016 "parse.y" /* yacc.c:1646  */
    { --in_record; }
#line 3607 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 100:
#line 1018 "parse.y" /* yacc.c:1646  */
    {
				set_location((yylsp[-5]), (yylsp[-1]));
				(yyval.type) = new RecordType((yyvsp[-2].type_decl_l));
				}
#line 3616 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 101:
#line 1024 "parse.y" /* yacc.c:1646  */
    {
				set_location((yylsp[-3]), (yylsp[0]));
				reporter->Error("union type not implemented");
				(yyval.type) = 0;
				}
#line 3626 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 102:
#line 1030 "parse.y" /* yacc.c:1646  */
    { set_location((yylsp[-1])); parse_new_enum(); }
#line 3632 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 103:
#line 1031 "parse.y" /* yacc.c:1646  */
    {
				set_location((yylsp[-4]), (yylsp[0]));
				(yyvsp[-1].type)->UpdateLocationEndInfo((yylsp[0]));
				(yyval.type) = (yyvsp[-1].type);
				}
#line 3642 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 104:
#line 1038 "parse.y" /* yacc.c:1646  */
    {
				set_location((yylsp[0]));
				// $$ = new TypeList();
				reporter->Error("list type not implemented");
				(yyval.type) = 0;
				}
#line 3653 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 105:
#line 1046 "parse.y" /* yacc.c:1646  */
    {
				set_location((yylsp[-2]));
				// $$ = new TypeList($3);
				reporter->Error("list type not implemented");
				(yyval.type) = 0;
				}
#line 3664 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 106:
#line 1054 "parse.y" /* yacc.c:1646  */
    {
				set_location((yylsp[-2]), (yylsp[0]));
				(yyval.type) = new VectorType({AdoptRef{}, (yyvsp[0].type)});
				}
#line 3673 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 107:
#line 1060 "parse.y" /* yacc.c:1646  */
    {
				set_location((yylsp[-1]), (yylsp[0]));
				(yyval.type) = (yyvsp[0].func_type);
				}
#line 3682 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 108:
#line 1066 "parse.y" /* yacc.c:1646  */
    {
				set_location((yylsp[-3]), (yylsp[-1]));
				(yyval.type) = new FuncType({AdoptRef{}, (yyvsp[-1].record)}, nullptr, FUNC_FLAVOR_EVENT);
				}
#line 3691 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 109:
#line 1072 "parse.y" /* yacc.c:1646  */
    {
				set_location((yylsp[-3]), (yylsp[-1]));
				(yyval.type) = new FuncType({AdoptRef{}, (yyvsp[-1].record)}, base_type(TYPE_BOOL), FUNC_FLAVOR_HOOK);
				}
#line 3700 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 110:
#line 1078 "parse.y" /* yacc.c:1646  */
    {
				set_location((yylsp[-2]), (yylsp[0]));
				(yyval.type) = new FileType({AdoptRef{}, (yyvsp[0].type)});
				}
#line 3709 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 111:
#line 1084 "parse.y" /* yacc.c:1646  */
    {
				set_location((yylsp[0]));
				(yyval.type) = new FileType(base_type(TYPE_STRING));
				}
#line 3718 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 112:
#line 1090 "parse.y" /* yacc.c:1646  */
    {
				set_location((yylsp[-2]), (yylsp[0]));
				(yyval.type) = new OpaqueType((yyvsp[0].str));
				}
#line 3727 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 113:
#line 1096 "parse.y" /* yacc.c:1646  */
    {
			if ( ! (yyvsp[0].id) || ! ((yyval.type) = (yyvsp[0].id)->IsType() ? (yyvsp[0].id)->GetType().get() : nullptr) )
				{
				NullStmt here;
				if ( (yyvsp[0].id) )
					(yyvsp[0].id)->Error("not a Zeek type", &here);
				(yyval.type) = error_type()->Ref();
				}
			else
				{
				Ref((yyval.type));

				if ( (yyvsp[0].id)->IsDeprecated() )
					reporter->Warning("%s", (yyvsp[0].id)->GetDeprecationWarning().c_str());
				}
			}
#line 3748 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 114:
#line 1116 "parse.y" /* yacc.c:1646  */
    { (yyvsp[-2].type_l)->AppendEvenIfNotPure({AdoptRef{}, (yyvsp[0].type)}); }
#line 3754 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 115:
#line 1118 "parse.y" /* yacc.c:1646  */
    {
			(yyval.type_l) = new TypeList({NewRef{}, (yyvsp[0].type)});
			(yyval.type_l)->Append({AdoptRef{}, (yyvsp[0].type)});
			}
#line 3763 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 116:
#line 1126 "parse.y" /* yacc.c:1646  */
    {
			(yyvsp[-1].type_decl_l)->push_back((yyvsp[0].type_decl));
			}
#line 3771 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 117:
#line 1130 "parse.y" /* yacc.c:1646  */
    {
			(yyval.type_decl_l) = new type_decl_list();
			}
#line 3779 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 118:
#line 1137 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-4]), (yylsp[-1]));
			auto attrs = make_attributes((yyvsp[-1].attr_l), {NewRef{}, (yyvsp[-2].type)}, in_record > 0, false);
			(yyval.type_decl) = new TypeDecl((yyvsp[-4].str), {AdoptRef{}, (yyvsp[-2].type)}, std::move(attrs));

			if ( in_record > 0 && cur_decl_type_id )
				zeekygen_mgr->RecordField(cur_decl_type_id, (yyval.type_decl), ::filename,
				                                        in_record_redef != 0);
			}
#line 3793 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 119:
#line 1150 "parse.y" /* yacc.c:1646  */
    { (yyval.record) = new RecordType((yyvsp[0].type_decl_l)); }
#line 3799 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 120:
#line 1152 "parse.y" /* yacc.c:1646  */
    { (yyval.record) = new RecordType((yyvsp[-1].type_decl_l)); }
#line 3805 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 121:
#line 1154 "parse.y" /* yacc.c:1646  */
    { (yyval.record) = new RecordType(new type_decl_list()); }
#line 3811 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 122:
#line 1159 "parse.y" /* yacc.c:1646  */
    { (yyvsp[-2].type_decl_l)->push_back((yyvsp[0].type_decl)); }
#line 3817 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 123:
#line 1161 "parse.y" /* yacc.c:1646  */
    { (yyvsp[-2].type_decl_l)->push_back((yyvsp[0].type_decl)); }
#line 3823 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 124:
#line 1163 "parse.y" /* yacc.c:1646  */
    { (yyval.type_decl_l) = new type_decl_list(); (yyval.type_decl_l)->push_back((yyvsp[0].type_decl)); }
#line 3829 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 125:
#line 1168 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-3]), (yylsp[0]));
			auto attrs = make_attributes((yyvsp[0].attr_l), {NewRef{}, (yyvsp[-1].type)}, true, false);
			(yyval.type_decl) = new TypeDecl((yyvsp[-3].str), {AdoptRef{}, (yyvsp[-1].type)}, std::move(attrs));
			}
#line 3839 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 126:
#line 1177 "parse.y" /* yacc.c:1646  */
    {
			current_module = (yyvsp[-1].str);
			zeekygen_mgr->ModuleUsage(::filename, current_module);
			}
#line 3848 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 127:
#line 1182 "parse.y" /* yacc.c:1646  */
    { is_export = true; }
#line 3854 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 128:
#line 1183 "parse.y" /* yacc.c:1646  */
    { is_export = false; }
#line 3860 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 129:
#line 1186 "parse.y" /* yacc.c:1646  */
    {
			build_global((yyvsp[-5].id), (yyvsp[-4].type), (yyvsp[-3].ic), (yyvsp[-2].expr), (yyvsp[-1].attr_l), VAR_REGULAR);
			}
#line 3868 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 130:
#line 1191 "parse.y" /* yacc.c:1646  */
    {
			build_global((yyvsp[-5].id), (yyvsp[-4].type), (yyvsp[-3].ic), (yyvsp[-2].expr), (yyvsp[-1].attr_l), VAR_OPTION);
			}
#line 3876 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 131:
#line 1196 "parse.y" /* yacc.c:1646  */
    {
			build_global((yyvsp[-5].id), (yyvsp[-4].type), (yyvsp[-3].ic), (yyvsp[-2].expr), (yyvsp[-1].attr_l), VAR_CONST);
			}
#line 3884 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 132:
#line 1201 "parse.y" /* yacc.c:1646  */
    {
			build_global((yyvsp[-5].id), (yyvsp[-4].type), (yyvsp[-3].ic), (yyvsp[-2].expr), (yyvsp[-1].attr_l), VAR_REDEF);
			}
#line 3892 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 133:
#line 1206 "parse.y" /* yacc.c:1646  */
    { ++in_enum_redef; parse_redef_enum((yyvsp[-2].id)); zeekygen_mgr->Redef((yyvsp[-2].id), ::filename); }
#line 3898 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 134:
#line 1208 "parse.y" /* yacc.c:1646  */
    {
			--in_enum_redef;
			// Zeekygen already grabbed new enum IDs as the type created them.
			}
#line 3907 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 135:
#line 1214 "parse.y" /* yacc.c:1646  */
    { cur_decl_type_id = (yyvsp[0].id); zeekygen_mgr->Redef((yyvsp[0].id), ::filename); }
#line 3913 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 136:
#line 1216 "parse.y" /* yacc.c:1646  */
    { ++in_record; ++in_record_redef; }
#line 3919 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 137:
#line 1218 "parse.y" /* yacc.c:1646  */
    { --in_record; --in_record_redef; }
#line 3925 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 138:
#line 1220 "parse.y" /* yacc.c:1646  */
    {
			cur_decl_type_id = 0;

			if ( ! (yyvsp[-9].id)->GetType() )
				(yyvsp[-9].id)->Error("unknown identifier");
			else
				extend_record((yyvsp[-9].id), std::unique_ptr<type_decl_list>((yyvsp[-4].type_decl_l)),
				              std::unique_ptr<std::vector<AttrPtr>>((yyvsp[-1].attr_l)));
			}
#line 3939 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 139:
#line 1231 "parse.y" /* yacc.c:1646  */
    { cur_decl_type_id = (yyvsp[-1].id); zeekygen_mgr->StartType({NewRef{}, (yyvsp[-1].id)});  }
#line 3945 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 140:
#line 1233 "parse.y" /* yacc.c:1646  */
    {
			cur_decl_type_id = 0;
			IntrusivePtr id{AdoptRef{}, (yyvsp[-5].id)};
			add_type(id.get(), {AdoptRef{}, (yyvsp[-2].type)},
			                       std::unique_ptr<std::vector<AttrPtr>>{(yyvsp[-1].attr_l)});
			zeekygen_mgr->Identifier(std::move(id));
			}
#line 3957 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 141:
#line 1242 "parse.y" /* yacc.c:1646  */
    {
			func_hdr_location = (yylsp[0]);
			func_hdr_cond_epoch = conditional_epoch;
			}
#line 3966 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 146:
#line 1257 "parse.y" /* yacc.c:1646  */
    { do_atif((yyvsp[-1].expr)); }
#line 3972 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 147:
#line 1259 "parse.y" /* yacc.c:1646  */
    { do_atifdef((yyvsp[-1].str)); }
#line 3978 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 148:
#line 1261 "parse.y" /* yacc.c:1646  */
    { do_atifndef((yyvsp[-1].str)); }
#line 3984 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 149:
#line 1263 "parse.y" /* yacc.c:1646  */
    { do_atendif(); }
#line 3990 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 150:
#line 1265 "parse.y" /* yacc.c:1646  */
    { do_atelse(); }
#line 3996 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 151:
#line 1270 "parse.y" /* yacc.c:1646  */
    {
			IntrusivePtr id{AdoptRef{}, (yyvsp[-2].id)};
			begin_func(id, current_module.c_str(),
				                     FUNC_FLAVOR_FUNCTION, false, {NewRef{}, (yyvsp[-1].func_type)},
			                         std::unique_ptr<std::vector<AttrPtr>>{(yyvsp[0].attr_l)});
			(yyval.func_type) = (yyvsp[-1].func_type);
			zeekygen_mgr->Identifier(std::move(id));
			}
#line 4009 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 152:
#line 1279 "parse.y" /* yacc.c:1646  */
    {
			const char* name = (yyvsp[-2].id)->Name();
			if ( util::streq("bro_init", name) || util::streq("bro_done", name) || util::streq("bro_script_loaded", name) )
				{
				auto base = std::string(name).substr(4);
				reporter->Error("event %s() is no longer available, use zeek_%s() instead", name, base.c_str());
				}

			begin_func({NewRef{}, (yyvsp[-2].id)}, current_module.c_str(),
				                     FUNC_FLAVOR_EVENT, false, {NewRef{}, (yyvsp[-1].func_type)},
			                         std::unique_ptr<std::vector<AttrPtr>>{(yyvsp[0].attr_l)});
			(yyval.func_type) = (yyvsp[-1].func_type);
			}
#line 4027 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 153:
#line 1293 "parse.y" /* yacc.c:1646  */
    {
			(yyvsp[-1].func_type)->ClearYieldType(FUNC_FLAVOR_HOOK);
			(yyvsp[-1].func_type)->SetYieldType(base_type(TYPE_BOOL));
			begin_func({NewRef{}, (yyvsp[-2].id)}, current_module.c_str(),
				                     FUNC_FLAVOR_HOOK, false, {NewRef{}, (yyvsp[-1].func_type)},
			                         std::unique_ptr<std::vector<AttrPtr>>{(yyvsp[0].attr_l)});
			(yyval.func_type) = (yyvsp[-1].func_type);
			}
#line 4040 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 154:
#line 1302 "parse.y" /* yacc.c:1646  */
    {
			begin_func({NewRef{}, (yyvsp[-2].id)}, current_module.c_str(),
				                     FUNC_FLAVOR_EVENT, true, {NewRef{}, (yyvsp[-1].func_type)},
			                         std::unique_ptr<std::vector<AttrPtr>>{(yyvsp[0].attr_l)});
			(yyval.func_type) = (yyvsp[-1].func_type);
			}
#line 4051 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 155:
#line 1312 "parse.y" /* yacc.c:1646  */
    {
			saved_in_init.push_back(in_init);
			in_init = 0;

			locals_at_this_scope.clear();
			out_of_scope_locals.clear();
			warned_about_locals.clear();
			}
#line 4064 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 156:
#line 1322 "parse.y" /* yacc.c:1646  */
    {
			in_init = saved_in_init.back();
			saved_in_init.pop_back();
			}
#line 4073 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 157:
#line 1328 "parse.y" /* yacc.c:1646  */
    {
			set_location(func_hdr_location, (yylsp[0]));

			bool free_of_conditionals = true;
			if ( current_file_has_conditionals ||
			     conditional_epoch > func_hdr_cond_epoch )
				free_of_conditionals = false;

			end_func({AdoptRef{}, (yyvsp[-2].stmt)}, free_of_conditionals);
			}
#line 4088 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 158:
#line 1342 "parse.y" /* yacc.c:1646  */
    {
			saved_in_init.push_back(in_init);
			in_init = 0;
			}
#line 4097 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 159:
#line 1348 "parse.y" /* yacc.c:1646  */
    {
			in_init = saved_in_init.back();
			saved_in_init.pop_back();
			}
#line 4106 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 160:
#line 1354 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-4]), (yylsp[0]));

			// Code duplication here is sad but needed.
			// end_func actually instantiates the function
			// and associates it with an ID. We perform that
			// association later and need to return a lambda
			// expression.

			// Gather the ingredients for a Func from the
			// current scope.
			auto ingredients = std::make_unique<function_ingredients>(
				current_scope(), IntrusivePtr{AdoptRef{}, (yyvsp[-2].stmt)});
			auto outer_ids = gather_outer_ids(pop_scope(), ingredients->body);

			(yyval.expr) = new LambdaExpr(std::move(ingredients), std::move(outer_ids));
			}
#line 4128 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 161:
#line 1375 "parse.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[0].expr); }
#line 4134 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 162:
#line 1380 "parse.y" /* yacc.c:1646  */
    {
			auto id = current_scope()->GenerateTemporary("anonymous-function");
			begin_func(id, current_module.c_str(), FUNC_FLAVOR_FUNCTION, false, {AdoptRef{}, (yyvsp[0].func_type)});

			std::optional<FuncType::CaptureList> captures;

			if ( (yyvsp[-1].captures) )
				{
				captures = FuncType::CaptureList{};
				captures->reserve((yyvsp[-1].captures)->size());

				for ( auto c : *(yyvsp[-1].captures) )
					{
					captures->emplace_back(*c);
					delete c;
					}

				delete (yyvsp[-1].captures);
				}

			(yyvsp[0].func_type)->SetCaptures(std::move(captures));
			(yyval.id) = id.release();
			}
#line 4162 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 163:
#line 1407 "parse.y" /* yacc.c:1646  */
    { (yyval.captures) = (yyvsp[-1].captures); }
#line 4168 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 164:
#line 1409 "parse.y" /* yacc.c:1646  */
    { (yyval.captures) = nullptr; }
#line 4174 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 165:
#line 1414 "parse.y" /* yacc.c:1646  */
    { (yyvsp[-2].captures)->push_back((yyvsp[0].capture)); }
#line 4180 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 166:
#line 1416 "parse.y" /* yacc.c:1646  */
    {
			(yyval.captures) = new std::vector<FuncType::Capture*>;
			(yyval.captures)->push_back((yyvsp[0].capture));
			}
#line 4189 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 167:
#line 1424 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[0]));
			auto id = lookup_ID((yyvsp[0].str),
					current_module.c_str());

			if ( ! id )
				reporter->Error("no such local identifier: %s", (yyvsp[0].str));
			else if ( id->IsType() )
				{
				reporter->Error("cannot specify type in capture: %s", (yyvsp[0].str));
				id = nullptr;
				}
			else if ( id->IsGlobal() )
				{
				reporter->Error("cannot specify global in capture: %s", (yyvsp[0].str));
				id = nullptr;
				}

			delete [] (yyvsp[0].str);

			(yyval.capture) = new FuncType::Capture;
			(yyval.capture)->id = id;
			(yyval.capture)->deep_copy = (yyvsp[-1].b);
			}
#line 4218 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 168:
#line 1451 "parse.y" /* yacc.c:1646  */
    { (yyval.b) = true; }
#line 4224 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 169:
#line 1453 "parse.y" /* yacc.c:1646  */
    { (yyval.b) = false; }
#line 4230 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 170:
#line 1458 "parse.y" /* yacc.c:1646  */
    { (yyval.func_type) = new FuncType({AdoptRef{}, (yyvsp[-3].record)}, {AdoptRef{}, (yyvsp[0].type)}, FUNC_FLAVOR_FUNCTION); }
#line 4236 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 171:
#line 1460 "parse.y" /* yacc.c:1646  */
    { (yyval.func_type) = new FuncType({AdoptRef{}, (yyvsp[-1].record)}, base_type(TYPE_VOID), FUNC_FLAVOR_FUNCTION); }
#line 4242 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 172:
#line 1465 "parse.y" /* yacc.c:1646  */
    { (yyval.type) = (yyvsp[0].type); }
#line 4248 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 173:
#line 1467 "parse.y" /* yacc.c:1646  */
    { (yyval.type) = 0; }
#line 4254 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 174:
#line 1471 "parse.y" /* yacc.c:1646  */
    { (yyval.ic) = INIT_NONE; }
#line 4260 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 175:
#line 1472 "parse.y" /* yacc.c:1646  */
    { (yyval.ic) = INIT_FULL; }
#line 4266 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 176:
#line 1473 "parse.y" /* yacc.c:1646  */
    { (yyval.ic) = INIT_EXTRA; }
#line 4272 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 177:
#line 1474 "parse.y" /* yacc.c:1646  */
    { (yyval.ic) = INIT_REMOVE; }
#line 4278 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 178:
#line 1478 "parse.y" /* yacc.c:1646  */
    { ++in_init; }
#line 4284 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 179:
#line 1478 "parse.y" /* yacc.c:1646  */
    { --in_init; }
#line 4290 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 180:
#line 1479 "parse.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[-1].expr); }
#line 4296 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 181:
#line 1481 "parse.y" /* yacc.c:1646  */
    { (yyval.expr) = 0; }
#line 4302 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 182:
#line 1486 "parse.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[-1].list); }
#line 4308 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 183:
#line 1488 "parse.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[-2].list); }
#line 4314 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 185:
#line 1494 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-5]), (yylsp[0]));

			auto low = (yyvsp[-3].expr) ? ExprPtr{AdoptRef{}, (yyvsp[-3].expr)} :
			                make_intrusive<ConstExpr>(val_mgr->Count(0));

			auto high = (yyvsp[-1].expr) ? ExprPtr{AdoptRef{}, (yyvsp[-1].expr)} :
			                 make_intrusive<SizeExpr>(
			                     ExprPtr{NewRef{}, (yyvsp[-5].expr)});

			if ( ! IsIntegral(low->GetType()->Tag()) || ! IsIntegral(high->GetType()->Tag()) )
				reporter->Error("slice notation must have integral values as indexes");

			auto le = make_intrusive<ListExpr>(std::move(low));
			le->Append(std::move(high));

			if ( in_when_cond > 0  )
				(yyval.expr) = new IndexExprWhen({AdoptRef{}, (yyvsp[-5].expr)}, std::move(le), true);
			else
				(yyval.expr) = new IndexExpr({AdoptRef{}, (yyvsp[-5].expr)}, std::move(le), true);
			}
#line 4340 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 187:
#line 1519 "parse.y" /* yacc.c:1646  */
    { (yyval.attr_l) = nullptr; }
#line 4346 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 188:
#line 1524 "parse.y" /* yacc.c:1646  */
    { (yyvsp[-1].attr_l)->emplace_back(AdoptRef{}, (yyvsp[0].attr)); }
#line 4352 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 189:
#line 1526 "parse.y" /* yacc.c:1646  */
    {
			(yyval.attr_l) = new std::vector<AttrPtr>;
			(yyval.attr_l)->emplace_back(AdoptRef{}, (yyvsp[0].attr));
			}
#line 4361 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 190:
#line 1534 "parse.y" /* yacc.c:1646  */
    { (yyval.attr) = new Attr(ATTR_DEFAULT, {AdoptRef{}, (yyvsp[0].expr)}); }
#line 4367 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 191:
#line 1536 "parse.y" /* yacc.c:1646  */
    { (yyval.attr) = new Attr(ATTR_OPTIONAL); }
#line 4373 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 192:
#line 1538 "parse.y" /* yacc.c:1646  */
    { (yyval.attr) = new Attr(ATTR_REDEF); }
#line 4379 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 193:
#line 1540 "parse.y" /* yacc.c:1646  */
    { (yyval.attr) = new Attr(ATTR_IS_ASSIGNED); }
#line 4385 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 194:
#line 1542 "parse.y" /* yacc.c:1646  */
    { (yyval.attr) = new Attr(ATTR_IS_USED); }
#line 4391 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 195:
#line 1544 "parse.y" /* yacc.c:1646  */
    { (yyval.attr) = new Attr(ATTR_ADD_FUNC, {AdoptRef{}, (yyvsp[0].expr)}); }
#line 4397 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 196:
#line 1546 "parse.y" /* yacc.c:1646  */
    { (yyval.attr) = new Attr(ATTR_DEL_FUNC, {AdoptRef{}, (yyvsp[0].expr)}); }
#line 4403 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 197:
#line 1548 "parse.y" /* yacc.c:1646  */
    { (yyval.attr) = new Attr(ATTR_ON_CHANGE, {AdoptRef{}, (yyvsp[0].expr)}); }
#line 4409 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 198:
#line 1550 "parse.y" /* yacc.c:1646  */
    { (yyval.attr) = new Attr(ATTR_BROKER_STORE, {AdoptRef{}, (yyvsp[0].expr)}); }
#line 4415 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 199:
#line 1552 "parse.y" /* yacc.c:1646  */
    { (yyval.attr) = new Attr(ATTR_BROKER_STORE_ALLOW_COMPLEX); }
#line 4421 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 200:
#line 1554 "parse.y" /* yacc.c:1646  */
    { (yyval.attr) = new Attr(ATTR_BACKEND, {AdoptRef{}, (yyvsp[0].expr)}); }
#line 4427 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 201:
#line 1556 "parse.y" /* yacc.c:1646  */
    { (yyval.attr) = new Attr(ATTR_EXPIRE_FUNC, {AdoptRef{}, (yyvsp[0].expr)}); }
#line 4433 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 202:
#line 1558 "parse.y" /* yacc.c:1646  */
    { (yyval.attr) = new Attr(ATTR_EXPIRE_CREATE, {AdoptRef{}, (yyvsp[0].expr)}); }
#line 4439 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 203:
#line 1560 "parse.y" /* yacc.c:1646  */
    { (yyval.attr) = new Attr(ATTR_EXPIRE_READ, {AdoptRef{}, (yyvsp[0].expr)}); }
#line 4445 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 204:
#line 1562 "parse.y" /* yacc.c:1646  */
    { (yyval.attr) = new Attr(ATTR_EXPIRE_WRITE, {AdoptRef{}, (yyvsp[0].expr)}); }
#line 4451 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 205:
#line 1564 "parse.y" /* yacc.c:1646  */
    { (yyval.attr) = new Attr(ATTR_RAW_OUTPUT); }
#line 4457 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 206:
#line 1566 "parse.y" /* yacc.c:1646  */
    { (yyval.attr) = new Attr(ATTR_PRIORITY, {AdoptRef{}, (yyvsp[0].expr)}); }
#line 4463 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 207:
#line 1568 "parse.y" /* yacc.c:1646  */
    { (yyval.attr) = new Attr(ATTR_TYPE_COLUMN, {AdoptRef{}, (yyvsp[0].expr)}); }
#line 4469 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 208:
#line 1570 "parse.y" /* yacc.c:1646  */
    { (yyval.attr) = new Attr(ATTR_LOG); }
#line 4475 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 209:
#line 1572 "parse.y" /* yacc.c:1646  */
    { (yyval.attr) = new Attr(ATTR_ERROR_HANDLER); }
#line 4481 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 210:
#line 1574 "parse.y" /* yacc.c:1646  */
    { (yyval.attr) = new Attr(ATTR_DEPRECATED); }
#line 4487 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 211:
#line 1576 "parse.y" /* yacc.c:1646  */
    {
			if ( IsString((yyvsp[0].val)->GetType()->Tag()) )
				(yyval.attr) = new Attr(
					ATTR_DEPRECATED,
					make_intrusive<ConstExpr>(IntrusivePtr{AdoptRef{}, (yyvsp[0].val)}));
			else
				{
				ODesc d;
				(yyvsp[0].val)->Describe(&d);
				Unref((yyvsp[0].val));
				reporter->Error("'&deprecated=%s' must use a string literal",
				                      d.Description());
				(yyval.attr) = new Attr(ATTR_DEPRECATED);
				}
			}
#line 4507 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 212:
#line 1595 "parse.y" /* yacc.c:1646  */
    {
			std::set<const ID*> id_set;
			locals_at_this_scope.emplace_back(id_set);
			}
#line 4516 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 213:
#line 1600 "parse.y" /* yacc.c:1646  */
    {
			auto& scope_locals = locals_at_this_scope.back();
			out_of_scope_locals.insert(scope_locals.begin(), scope_locals.end());
			locals_at_this_scope.pop_back();

			set_location((yylsp[-4]), (yylsp[0]));
			(yyval.stmt) = (yyvsp[-1].stmt);
			if ( (yyvsp[-2].b) )
			    script_coverage_mgr.DecIgnoreDepth();
			}
#line 4531 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 214:
#line 1612 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-3]), (yylsp[-1]));
			(yyval.stmt) = new PrintStmt(IntrusivePtr{AdoptRef{}, (yyvsp[-2].list)});
			if ( ! (yyvsp[0].b) )
			    script_coverage_mgr.AddStmt((yyval.stmt));
			}
#line 4542 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 215:
#line 1620 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-3]), (yylsp[-1]));
			(yyval.stmt) = new EventStmt({AdoptRef{}, (yyvsp[-2].event_expr)});
			if ( ! (yyvsp[0].b) )
			    script_coverage_mgr.AddStmt((yyval.stmt));
			}
#line 4553 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 216:
#line 1628 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-4]), (yylsp[-1]));
			(yyval.stmt) = new IfStmt({AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].stmt)}, make_intrusive<NullStmt>());
			}
#line 4562 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 217:
#line 1634 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-6]), (yylsp[-3]));
			(yyval.stmt) = new IfStmt({AdoptRef{}, (yyvsp[-4].expr)}, {AdoptRef{}, (yyvsp[-2].stmt)}, {AdoptRef{}, (yyvsp[0].stmt)});
			}
#line 4571 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 218:
#line 1640 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-4]), (yylsp[-3]));
			(yyval.stmt) = new SwitchStmt({AdoptRef{}, (yyvsp[-3].expr)}, (yyvsp[-1].case_l));
			}
#line 4580 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 219:
#line 1646 "parse.y" /* yacc.c:1646  */
    {
			(yyvsp[-1].stmt)->AsForStmt()->AddBody({AdoptRef{}, (yyvsp[0].stmt)});
			}
#line 4588 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 220:
#line 1651 "parse.y" /* yacc.c:1646  */
    {
			(yyval.stmt) = new WhileStmt({AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].stmt)});
			}
#line 4596 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 221:
#line 1656 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[-1]));
			(yyval.stmt) = new NextStmt;
			if ( ! (yyvsp[0].b) )
			    script_coverage_mgr.AddStmt((yyval.stmt));
			}
#line 4607 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 222:
#line 1664 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[-1]));
			(yyval.stmt) = new BreakStmt;
			if ( ! (yyvsp[0].b) )
			    script_coverage_mgr.AddStmt((yyval.stmt));
			}
#line 4618 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 223:
#line 1672 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[-1]));
			(yyval.stmt) = new FallthroughStmt;
			if ( ! (yyvsp[0].b) )
				script_coverage_mgr.AddStmt((yyval.stmt));
			}
#line 4629 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 224:
#line 1680 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[-1]));
			(yyval.stmt) = new ReturnStmt(0);
			if ( ! (yyvsp[0].b) )
			    script_coverage_mgr.AddStmt((yyval.stmt));
			}
#line 4640 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 225:
#line 1688 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-3]), (yylsp[-2]));
			(yyval.stmt) = new ReturnStmt({AdoptRef{}, (yyvsp[-2].expr)});
			if ( ! (yyvsp[0].b) )
			    script_coverage_mgr.AddStmt((yyval.stmt));
			}
#line 4651 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 226:
#line 1696 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-3]), (yylsp[-1]));
			(yyval.stmt) = new AddStmt({AdoptRef{}, (yyvsp[-2].expr)});
			if ( ! (yyvsp[0].b) )
			    script_coverage_mgr.AddStmt((yyval.stmt));
			}
#line 4662 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 227:
#line 1704 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-3]), (yylsp[-1]));
			(yyval.stmt) = new DelStmt({AdoptRef{}, (yyvsp[-2].expr)});
			if ( ! (yyvsp[0].b) )
			    script_coverage_mgr.AddStmt((yyval.stmt));
			}
#line 4673 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 228:
#line 1712 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-7]), (yylsp[-1]));
			if ( ! locals_at_this_scope.empty() )
			       locals_at_this_scope.back().insert((yyvsp[-6].id));
			(yyval.stmt) = build_local((yyvsp[-6].id), (yyvsp[-5].type), (yyvsp[-4].ic), (yyvsp[-3].expr), (yyvsp[-2].attr_l), VAR_REGULAR, ! (yyvsp[0].b)).release();
			}
#line 4684 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 229:
#line 1720 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-7]), (yylsp[-2]));
			(yyval.stmt) = build_local((yyvsp[-6].id), (yyvsp[-5].type), (yyvsp[-4].ic), (yyvsp[-3].expr), (yyvsp[-2].attr_l), VAR_CONST, ! (yyvsp[0].b)).release();
			}
#line 4693 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 230:
#line 1726 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.stmt) = new WhenStmt({AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].stmt)},
			                                  nullptr, nullptr, false);
			}
#line 4703 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 231:
#line 1733 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-8]), (yylsp[-2]));
			(yyval.stmt) = new WhenStmt({AdoptRef{}, (yyvsp[-8].expr)}, {AdoptRef{}, (yyvsp[-6].stmt)},
			                                  {AdoptRef{}, (yyvsp[-1].stmt)}, {AdoptRef{}, (yyvsp[-4].expr)}, false);
			if ( (yyvsp[-2].b) )
			    script_coverage_mgr.DecIgnoreDepth();
			}
#line 4715 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 232:
#line 1743 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.stmt) = new WhenStmt({AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].stmt)}, nullptr,
			                  nullptr, true);
			}
#line 4725 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 233:
#line 1750 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-8]), (yylsp[-2]));
			(yyval.stmt) = new WhenStmt({AdoptRef{}, (yyvsp[-8].expr)}, {AdoptRef{}, (yyvsp[-6].stmt)},
			                                  {AdoptRef{}, (yyvsp[-1].stmt)}, {AdoptRef{}, (yyvsp[-4].expr)}, true);
			if ( (yyvsp[-2].b) )
			    script_coverage_mgr.DecIgnoreDepth();
			}
#line 4737 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 234:
#line 1759 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-4]), (yylsp[-1]));
			(yyval.stmt) = new ExprStmt(get_assign_expr({AdoptRef{}, (yyvsp[-4].expr)},
			                                  {AdoptRef{}, (yyvsp[-2].expr)}, in_init));

			if ( ! (yyvsp[0].b) )
				script_coverage_mgr.AddStmt((yyval.stmt));
			}
#line 4750 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 235:
#line 1769 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[-1]));
			(yyval.stmt) = new ExprStmt({AdoptRef{}, (yyvsp[-2].expr)});
			if ( ! (yyvsp[0].b) )
			    script_coverage_mgr.AddStmt((yyval.stmt));
			}
#line 4761 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 236:
#line 1777 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[0]), (yylsp[0]));
			(yyval.stmt) = new NullStmt;
			}
#line 4770 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 237:
#line 1783 "parse.y" /* yacc.c:1646  */
    { (yyval.stmt) = new NullStmt; }
#line 4776 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 238:
#line 1788 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-1]), (yylsp[0]));
			(yyvsp[-1].stmt)->AsStmtList()->Stmts().push_back((yyvsp[0].stmt));
			(yyvsp[-1].stmt)->UpdateLocationEndInfo((yylsp[0]));
			}
#line 4786 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 239:
#line 1794 "parse.y" /* yacc.c:1646  */
    { (yyval.stmt) = new StmtList(); }
#line 4792 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 240:
#line 1799 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-3]), (yylsp[0]));
			const auto& id = lookup_ID((yyvsp[-3].str), current_module.c_str());

			if ( id )
				{
				if ( ! id->IsGlobal() )
					{
					yyerror(util::fmt("local identifier \"%s\" cannot be used to reference an event", (yyvsp[-3].str)));
					YYERROR;
					}

				if ( id->IsDeprecated() )
					reporter->Warning("%s", id->GetDeprecationWarning().c_str());
				}

			(yyval.event_expr) = new EventExpr((yyvsp[-3].str), {AdoptRef{}, (yyvsp[-1].list)});
			}
#line 4815 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 241:
#line 1821 "parse.y" /* yacc.c:1646  */
    { (yyvsp[-1].case_l)->push_back((yyvsp[0].c_case)); }
#line 4821 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 242:
#line 1823 "parse.y" /* yacc.c:1646  */
    { (yyval.case_l) = new case_list; }
#line 4827 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 243:
#line 1828 "parse.y" /* yacc.c:1646  */
    { (yyval.c_case) = new Case({AdoptRef{}, (yyvsp[-2].list)}, nullptr, {AdoptRef{}, (yyvsp[0].stmt)}); }
#line 4833 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 244:
#line 1831 "parse.y" /* yacc.c:1646  */
    { (yyval.c_case) = new Case(nullptr, (yyvsp[-2].id_l), {AdoptRef{}, (yyvsp[0].stmt)}); }
#line 4839 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 245:
#line 1834 "parse.y" /* yacc.c:1646  */
    { (yyval.c_case) = new Case(nullptr, nullptr, {AdoptRef{}, (yyvsp[0].stmt)}); }
#line 4845 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 246:
#line 1839 "parse.y" /* yacc.c:1646  */
    { (yyvsp[-2].id_l)->push_back((yyvsp[0].id)); }
#line 4851 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 247:
#line 1842 "parse.y" /* yacc.c:1646  */
    {
			(yyval.id_l) = new IDPList;
			(yyval.id_l)->push_back((yyvsp[0].id));
			}
#line 4860 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 248:
#line 1850 "parse.y" /* yacc.c:1646  */
    {
			(yyval.id) = new ID(0, SCOPE_FUNCTION, 0);
			(yyval.id)->SetType({AdoptRef{}, (yyvsp[0].type)});
			}
#line 4869 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 249:
#line 1856 "parse.y" /* yacc.c:1646  */
    {
			const char* name = (yyvsp[0].str);
			TypePtr type{AdoptRef{}, (yyvsp[-2].type)};
			auto case_var = lookup_ID(name, current_module.c_str());

			if ( case_var && case_var->IsGlobal() )
				case_var->Error("already a global identifier");
			else
				case_var = install_ID(name, current_module.c_str(), false, false);

			add_local(case_var, std::move(type), INIT_NONE, nullptr, nullptr,
			                        VAR_REGULAR);
			(yyval.id) = case_var.release();
			}
#line 4888 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 250:
#line 1873 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-5]), (yylsp[0]));

			// This rule needs to be separate from the loop
			// body so that we execute these actions - defining
			// the local variable - prior to parsing the body,
			// which might refer to the variable.
			auto loop_var = lookup_ID((yyvsp[-3].str), current_module.c_str());

			if ( loop_var )
				{
				if ( loop_var->IsGlobal() )
					loop_var->Error("global variable used in for loop");
				}

			else
				{
				loop_var = install_ID((yyvsp[-3].str), current_module.c_str(),
				                                    false, false);
				}

			auto* loop_vars = new IDPList;
			loop_vars->push_back(loop_var.release());

			(yyval.stmt) = new ForStmt(loop_vars, {AdoptRef{}, (yyvsp[-1].expr)});
			}
#line 4919 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 251:
#line 1901 "parse.y" /* yacc.c:1646  */
    {
			(yyval.stmt) = new ForStmt((yyvsp[-4].id_l), {AdoptRef{}, (yyvsp[-1].expr)});
			}
#line 4927 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 252:
#line 1906 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-7]), (yylsp[0]));
			const char* module = current_module.c_str();

			// Check for previous definitions of key and
			// value variables.
			auto key_var = lookup_ID((yyvsp[-5].str), module);
			auto val_var = lookup_ID((yyvsp[-3].str), module);

			// Validate previous definitions as needed.
			if ( key_var )
				{
				if ( key_var->IsGlobal() )
					key_var->Error("global variable used in for loop");
				}
			else
				key_var = install_ID((yyvsp[-5].str), module, false, false);

			if ( val_var )
				{
				if ( val_var->IsGlobal() )
					val_var->Error("global variable used in for loop");
				}
			else
				val_var = install_ID((yyvsp[-3].str), module, false, false);

			auto* loop_vars = new IDPList;
			loop_vars->push_back(key_var.release());

			(yyval.stmt) = new ForStmt(loop_vars, {AdoptRef{}, (yyvsp[-1].expr)}, std::move(val_var));
			}
#line 4963 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 253:
#line 1939 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-9]), (yylsp[0]));
			const char* module = current_module.c_str();

			// Validate value variable
			auto val_var = lookup_ID((yyvsp[-3].str), module);

			if ( val_var )
				{
				if ( val_var->IsGlobal() )
					val_var->Error("global variable used in for loop");
				}
			else
				val_var = install_ID((yyvsp[-3].str), module, false, false);

			(yyval.stmt) = new ForStmt((yyvsp[-6].id_l), {AdoptRef{}, (yyvsp[-1].expr)}, std::move(val_var));
			}
#line 4985 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 254:
#line 1960 "parse.y" /* yacc.c:1646  */
    { (yyvsp[-2].id_l)->push_back((yyvsp[0].id)); }
#line 4991 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 255:
#line 1962 "parse.y" /* yacc.c:1646  */
    {
			(yyval.id_l) = new IDPList;
			(yyval.id_l)->push_back((yyvsp[0].id));
			}
#line 5000 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 256:
#line 1970 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[0]));
			auto id = lookup_ID((yyvsp[0].str), current_module.c_str());
			(yyval.id) = id.release();

			if ( (yyval.id) )
				{
				if ( (yyval.id)->IsGlobal() )
					(yyval.id)->Error("already a global identifier");
				delete [] (yyvsp[0].str);
				}

			else
				{
				(yyval.id) = install_ID((yyvsp[0].str), current_module.c_str(),
				                              false, is_export).release();
				}
			}
#line 5023 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 257:
#line 1991 "parse.y" /* yacc.c:1646  */
    { resolving_global_ID = 1; }
#line 5029 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 258:
#line 1992 "parse.y" /* yacc.c:1646  */
    { (yyval.id) = (yyvsp[0].id); }
#line 5035 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 259:
#line 1996 "parse.y" /* yacc.c:1646  */
    { defining_global_ID = 1; }
#line 5041 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 260:
#line 1996 "parse.y" /* yacc.c:1646  */
    { defining_global_ID = 0; }
#line 5047 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 261:
#line 1997 "parse.y" /* yacc.c:1646  */
    { (yyval.id) = (yyvsp[-1].id); }
#line 5053 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 262:
#line 2001 "parse.y" /* yacc.c:1646  */
    { resolving_global_ID = 0; }
#line 5059 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 263:
#line 2002 "parse.y" /* yacc.c:1646  */
    { (yyval.id) = (yyvsp[0].id); }
#line 5065 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 264:
#line 2007 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[0]));
			auto id = lookup_ID((yyvsp[0].str), current_module.c_str(), false,
			                    defining_global_ID);
			(yyval.id) = id.release();

			if ( (yyval.id) )
				{
				if ( ! (yyval.id)->IsGlobal() )
					(yyval.id)->Error("already a local identifier");

				if ( (yyval.id)->IsDeprecated() )
					{
					const auto& t = (yyval.id)->GetType();

					if ( t->Tag() != TYPE_FUNC ||
					     t->AsFuncType()->Flavor() != FUNC_FLAVOR_FUNCTION )
						reporter->Warning("%s", (yyval.id)->GetDeprecationWarning().c_str());
					}

				delete [] (yyvsp[0].str);
				}

			else
				{
				const char* module_name =
					resolving_global_ID ?
						current_module.c_str() : 0;

				(yyval.id) = install_ID((yyvsp[0].str), module_name,
				                              true, is_export).release();
				}
			}
#line 5103 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 265:
#line 2045 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[0]));
			auto id = lookup_ID((yyvsp[0].str), current_module.c_str());
			(yyval.id) = id.release();

			if ( ! (yyval.id) )
				reporter->Error("identifier not defined: %s", (yyvsp[0].str));

			delete [] (yyvsp[0].str);
			}
#line 5118 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 266:
#line 2059 "parse.y" /* yacc.c:1646  */
    { (yyval.b) = true; }
#line 5124 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 267:
#line 2061 "parse.y" /* yacc.c:1646  */
    { (yyval.b) = false; }
#line 5130 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 268:
#line 2065 "parse.y" /* yacc.c:1646  */
    { (yyval.b) = true; script_coverage_mgr.IncIgnoreDepth(); }
#line 5136 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 269:
#line 2067 "parse.y" /* yacc.c:1646  */
    { (yyval.b) = false; }
#line 5142 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 270:
#line 2071 "parse.y" /* yacc.c:1646  */
    { (yyval.expr) = new ConstExpr(make_intrusive<StringVal>("")); }
#line 5148 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 271:
#line 2074 "parse.y" /* yacc.c:1646  */
    {
			if ( IsString((yyvsp[0].val)->GetType()->Tag()) )
				(yyval.expr) = new ConstExpr({AdoptRef{}, (yyvsp[0].val)});
			else
				{
				ODesc d;
				(yyvsp[0].val)->Describe(&d);
				reporter->Error("'&deprecated=%s' must use a string literal",
				                      d.Description());
				(yyval.expr) = new ConstExpr(make_intrusive<StringVal>(""));
				}
			}
#line 5165 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;

  case 272:
#line 2087 "parse.y" /* yacc.c:1646  */
    { (yyval.expr) = nullptr; }
#line 5171 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
    break;


#line 5175 "/builddir/build/BUILD/zeek-4.2.0/aarch64-redhat-linux-gnu/src/p.cc" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }

  yyerror_range[1] = yylloc;

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, &yylloc);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  yyerror_range[1] = yylsp[1-yylen];
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp, yylsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  yyerror_range[2] = yylloc;
  /* Using YYLLOC is tempting, but would change the location of
     the lookahead.  YYLOC is available though.  */
  YYLLOC_DEFAULT (yyloc, yyerror_range, 2);
  *++yylsp = yyloc;

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp, yylsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 2089 "parse.y" /* yacc.c:1906  */


int yyerror(const char msg[])
	{
	if ( in_debug )
		g_curr_debug_error = util::copy_string(msg);

	if ( last_tok[0] == '\n' )
		reporter->Error("%s, on previous line", msg);
	else if ( last_tok[0] == '\0' )
		{
		if ( last_filename )
			reporter->Error("%s, at end of file %s", msg, last_filename);
		else
			reporter->Error("%s, at end of file", msg);
		}
	else
		{
		if ( last_last_tok_filename && last_tok_filename &&
		     ! util::streq(last_last_tok_filename, last_tok_filename) )
			reporter->Error("%s, at or near \"%s\" or end of file %s",
			                      msg, last_tok, last_last_tok_filename);
		else
			reporter->Error("%s, at or near \"%s\"", msg, last_tok);
		}

	return 0;
	}
